unit fMHA_InstrumentSelect;

interface

uses
  Windows,
  Messages,
  SysUtils,
  System.Contnrs,
  System.UITypes,
  Classes,
  Graphics,
  Controls,
  Forms,
  ExtCtrls,
  StdCtrls,
  Grids,
  Menus,
  Buttons,
  ORCtrls,
  ImgList,
  RzLabel,
  RzPanel,
  ShellApi,
  dwlcore,  //-- removed until fixed, this is the dwinLock component
  jclSysInfo,
  VirtualTrees,
  JvExControls,
  JvComponent,
  JvXPCore,
  JvXPButtons,
  Mask,
  JvExMask,
  JvToolEdit,
  JvDatePickerEdit,
  ComCtrls,
  Dialogs,
  // llh patch 129 added DateUtils
  DateUtils,
  System.ImageList;

type

  TfrmMHA_InstrumentSelect = class(TForm)
    pnlBottom: TPanel;
    pnlLists: TPanel;
    grpAvailable: TGroupBox;
    pnlLow1: TPanel;
    pnlSpacer0: TPanel;
    pnlLeft: TPanel;
    grpOrderer: TGroupBox;
    cbxOrderedBy: TORComboBox;
    grpDate: TGroupBox;
    pnlSpacer2: TPanel;
    pnlSpacer1: TPanel;
    pnlSort: TPanel;
    cbxSortBy: TComboBox;
    pnlRight: TPanel;
    pnlSpacer3: TPanel;
    btnUp: TBitBtn;
    btnDown: TBitBtn;
    pnlAction: TPanel;
    grpChosen: TGroupBox;
    btnRemove: TBitBtn;
    grpInstructions: TGroupBox;
    mnuMain: TMainMenu;
    mnuFile: TMenuItem;
    mnuSelectPatient: TMenuItem;
    N1: TMenuItem;
    mnuExit: TMenuItem;
    mnuTools: TMenuItem;
    mnuOptions: TMenuItem;
    ImageList1: TImageList;
    lstChosen: TListView;
    PopupMenu1: TPopupMenu;
    mnuDescription: TMenuItem;
    lblSort: TLabel;
    pnlHeader: TRzPanel;
    lblHeader: TRzLabel;
    lblPatient: TRzLabel;
    mnuMetric: TMenuItem;
    mnuHelp: TMenuItem;
    mnuInstrumentDescription: TMenuItem;
    N2: TMenuItem;
    mnuBattery: TMenuItem;
    N3: TMenuItem;
    mnuOnlineSupport: TMenuItem;
    N4: TMenuItem;
    mnuAbout: TMenuItem;
    grpInterview: TGroupBox;
    cbxInterviewer: TORComboBox;
    grpLocation: TGroupBox;
    lblInstructions: TLabel;
    cbxLocation: TORComboBox;
    pnlActionRight: TPanel;
    pnlRadio: TPanel;
    lblDisplay: TLabel;
    rbOneAtATime: TRadioButton;
    rbAllAtOnce: TRadioButton;
    treSelect: TVirtualStringTree;
    btnPatientEntry: TJvXPButton;
    btnStaffEntry: TJvXPButton;
    imgBackup: TImage;
    mnuPrintBlank: TMenuItem;
    dtpkAdministration: TDateTimePicker;
    grpConsult: TGroupBox;
    cbxConsult: TORComboBox;
    OpenDialog1: TOpenDialog;
    lbSelect: TListBox;
    lblPatientScrRdr: TStaticText;
    btnScrRdrExit: TJvXPButton;

    procedure btnStaffEntryClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbxSortByChange(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    procedure btnRemoveClick(Sender: TObject);
    procedure cbxSortByEnter(Sender: TObject);
    procedure dtpkAdministrationChange(Sender: TObject);
    procedure mnuSelectPatientClick(Sender: TObject);
    procedure btnUpClick(Sender: TObject);
    procedure btnDownClick(Sender: TObject);
    procedure lstChosenEnter(Sender: TObject);
    procedure lstChosenDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure lstChosenDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lstChosenMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mnuDescriptionClick(Sender: TObject);
    procedure lstChosenExit(Sender: TObject);
    procedure lstChosenMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure grpOrdererMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure grpDateMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure pnlSortMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure grpInstructionsMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure cbxOrderedByNeedData(Sender: TObject;
      const StartFrom: string; Direction, InsertAt: Integer);
    procedure mnuMetricClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbxOrderedByDropDown(Sender: TObject);
    procedure cbxOrderedByChange(Sender: TObject);
    procedure mnuOptionsClick(Sender: TObject);
    //procedure chkAlphaInstrumentsMouseDown(Sender: TObject;
    //  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure mnuBatteryClick(Sender: TObject);
    procedure btnPatientEntryClick(Sender: TObject);

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnPatientEntryMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure btnStaffEntryMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure rgrpAdministrationMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure cbxOrderedByEnter(Sender: TObject);
    procedure dtpkAdministrationEnter(Sender: TObject);
    procedure rgrpAdministrationEnter(Sender: TObject);
    procedure lblHeaderMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure mnuExitClick(Sender: TObject);
    procedure mnuOnlineSupportClick(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure cbxInterviewerChange(Sender: TObject);
    procedure cbxInterviewerEnter(Sender: TObject);
    procedure cbxInterviewerDropDown(Sender: TObject);
    procedure grpInterviewMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure cbxLocationChange(Sender: TObject);
    procedure cbxConsultChange(Sender: TObject);
    procedure grpLocationMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure grpConsultMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure cbxLocationEnter(Sender: TObject);
    procedure cbxConsultEnter(Sender: TObject);
    procedure cbxLocationDropDown(Sender: TObject);
    procedure cbxConsultDropDown(Sender: TObject);
    procedure cbxLocationNeedData(Sender: TObject; const StartFrom: string;
      Direction, InsertAt: Integer);
    procedure rbOneAtATimeMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure rbOneAtATimeEnter(Sender: TObject);

    procedure treSelectGetText(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: string);
    function treSelectGetChildCount(NodeIn: string): Integer;
    function treSelectGetHasChildren(NodeName: string): Boolean;
    procedure treSelectInitChildren(Sender: TBaseVirtualTree;
      Node: PVirtualNode; var ChildCount: Cardinal);
    function treSelectGetItems(PNode: string; ChildNumber: integer): string;
    procedure treSelectInitNode(Sender: TBaseVirtualTree; ParentNode, Node:
      PVirtualNode; var InitialStates: TVirtualNodeInitStates);
    procedure treSelectChecked(Sender: TBaseVirtualTree;
      Node: PVirtualNode);
    procedure treSelectEnter(Sender: TObject);
    procedure treSelectMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure treSelectUnCheck;
    procedure treSelectUnCheckThisNode(ThisNode: string);
    procedure treSelectPaintText(Sender: TBaseVirtualTree;
      const TargetCanvas: TCanvas; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType);
    procedure treSelectGetImageIndex(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
      var Ghosted: Boolean; var ImageIndex: Integer);
    procedure treSelectClick(Sender: TObject);
    procedure imgBackupClick(Sender: TObject);
    procedure treSelectDblClick(Sender: TObject);
    procedure mnuPrintBlankClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure rbAllAtOnceClick(Sender: TObject);
    procedure rbOneAtATimeClick(Sender: TObject);
    //procedure OnClickCheckBox(Sender: TObject);
    //procedure mnuImportClick(Sender: TObject);
    procedure treSelectGetHint(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex;
      var LineBreakStyle: TVTTooltipLineBreakStyle; var HintText: string);
    procedure lbSelectKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnScrRdrExitClick(Sender: TObject);
    procedure dtpkAdministrationExit(Sender: TObject);

  private
    { Private declarations }
    FIsSecureDesktopAvailable: BOOLEAN;

    //procedure PrepareListOfInstruments(aUserKeys:string);
    procedure PrepareListOfIncompletes;
    procedure UpdateButtons;
    procedure ConfigureForm(Sender: TObject);
    procedure UpdateInstrumentResourceFiles;
    procedure BuildListOfSelectedInstruments;
    procedure DisplaySelectedInstruments;
    procedure DisplayEverything;
    procedure DisplayBatteries;
    procedure DisplayReStartables;
    procedure ScreenReaderDisplayEverything;
    procedure ScreenReaderUnCheckThisOne(ThisOne: string);
    procedure LoadImageLists;
    procedure lstChosenRedundant;
    procedure RemoveDeselectedInstrument(AInstrument: string);
    procedure SendEMailToOrderer;
    function InstrumentAllowed(WhichOne: string): boolean;
    function GetInstrumentDetails(aInstrumentName: string): string;

    //va_SecureDesktop functions
    function IsSecureDesktopInstalled: BOOLEAN;
    procedure Startva_SecureDesktop;

  public
    { Public declarations }
    procedure NewPatientDisplay;
    property IsSecureDesktopAvailable: BOOLEAN read FIsSecureDesktopAvailable
      write FIsSecureDesktopAvailable;

  end;

var
  frmMHA_InstrumentSelect     : TfrmMHA_InstrumentSelect;

  IconBattery,
    IconInstrument,
    IconIncomplete            : Integer;

implementation

uses
  uIA_Const,
  uMHA_Const,
  uIA_GUIControl,
  uMHA_Registry,
  fIA_dialogs,
  uIA_Utils,
  uIA_ThisUser,
  uIA_Staff_OPS,
  uIA_Consult_OPS,
  uIA_Patient,
  uIA_Patient_OPS,
  uIA_AvailableInstrument,
  uIA_Instrument,
  uMHA_Instrument_OPS,
  uMHA_LocalFiles,
  uMHA_Proctor,
  uMHA_Administration,
  uMHA_Administration_OPS,
  fMHA_About,
  fMHA_Main,
  fMHA_Options,
  fMHA_Options_508,
  fMHA_SD_Warning,
  uMHA_Battery,
  uMHA_Battery_OPS,
  fMHA_AdministerAllItems,
  fMHA_AdministerOneItem,
  fMHA_SelectPatient,
  fMHA_BatteryWizard,
  uMHA_Location_IO,
  uMHA_ResourceFile_OPS,
  fMHA_InstrumentDescription,
  uMHA_DM,
  fMHA_Print_Blank;
  //uMHA_Import;

type
  // Node data record
  PSelectData = ^TSelectData;

  TSelectData = record
    // patch 129 llh XE8; was WideString, changed component incompatible
    Caption: string;
    Style: Char; // B,I,R (Battery, Incomplete, Regular)
    ImageIndex: Integer;
  end;


const
  HEADERCAPTION               = '  Instrument Administrator';
  ALL                         = 'All';
  RESTARTABLE                 = 'Restartable only';
  BATTERY                     = 'Batteries only';

var
  // "lv" Local Variable
  lvCurrentOrdererDUZ         : string;

  lvNodeHeight,
    lvRootNode,
    lvChildren                : Integer;
  lvInitialize,
    lvShowOffLinePrompt       : Boolean;
  lvInstrumentHint,
    lvtreSelectItems          : TStringList;
  lvAdministration            : TAdministration;

{$R *.DFM}
{$R iMHAnew.res} // Contains icons for instruments
//{$R iMHA.res} // Contains icons for instruments

//------------------------------------------------------------------------------
//            Create, Show and Close
//------------------------------------------------------------------------------

procedure TfrmMHA_InstrumentSelect.FormCreate(Sender: TObject);
var
  Reply                       : string;

  procedure SorryMessage;
  var
    tmpMsg                    : string;
  begin
    tmpMsg :=
      'Sorry, but a list of available instruments could not be found on ';
    if (DataBaseMode = dbVista) then
      tmpMsg := tmpMsg + 'VistA.'
    else
      tmpMsg := tmpMsg + 'this PC.' + CRLF + CRLF
        + 'Try connecting to VistA to rebuild the necessary files on your PC, and '
        + 'then see if you can run MHA off-line.';
    MsgDlgFrm(tmpMsg, MHA_Caption, mtWarning, [mbOK], 0);
    Halt;
  end;

begin
  lvInitialize := True;
  lvShowOffLinePrompt := False;
  Position := poDesigned;
  lvtreSelectItems := TStringList.Create;
  lvInstrumentHint := TStringList.Create;

  lvAdministration := TAdministration.Create;
  Administration_OPS.ClearAdmin(lvAdministration);
  // DateGiven is not reset in lvAdministration.Clear
  lvAdministration.DateGiven := Now;

  gvProgressNoteIEN := '';

  // Off-line: User is set to
  //   Name: Off-line,
  //   DUZ = No_ID.  See uIA_ThisUser_IO
  lvCurrentOrdererDUZ := ThisUser.DUZ;
  lvAdministration.Orderer.DUZ := ThisUser.DUZ;
  lvAdministration.AdministeredBy := ThisUser.DUZ;

  reply := Instrument_OPS.LoadListOfAvailableInstruments(lvAdministration.Orderer.AccessKeys);
  if reply <> OK then
    begin
      MsgDlgFrm(' Sorry, there is an error loading the instruments: ' + #13 + reply,
        MHA_Caption, mtError, [mbOK], 0);
      Exit;
    end;

  if (DataBaseMode = dbVistA) then
    begin
      // Do this once
      if gvCheckResourceFiles then
        begin
          UpdateInstrumentResourceFiles;
          gvCheckResourceFiles := False;
        end;

      cbxOrderedBy.Text := ThisUser.Name;
      cbxInterviewer.Text := ThisUser.Name;

      if (Piece(gvLastLocation, U, 1) = '-1') or
        (Piece(gvLastLocation, U, 1) = ' ') or
        (Piece(gvLastLocation, U, 1) = '') then
        begin
          cbxLocation.InitLongList('');
          cbxLocation.ItemIndex := -1;
        end
      else
        begin
          cbxLocation.InitLongList(Piece(gvLastLocation, U, 2));
          cbxLocation.ItemIndex :=
            cbxlocation.SelectByIEN(StrToIntDef(Piece(gvLastLocation,
            U, 1), 0));
        end;

      lvAdministration.LocationIEN := IntToStr(cbxLocation.ItemIEN);
      lvAdministration.LocationStr := cbxLocation.Text;

      reply := Battery_OPS.LoadBatteries;

      if (reply = '0') or (reply = OK) then // do nothing
      else
        MsgDlgFrm('Sorry, an error has occurred while loading the batteries. ' +
          #13 + #13 + Reply, MHA_Caption, mtError, [mbok], 0);

      PrepareListOfIncompletes;
       // Set defaults
      cbxSortBy.ItemIndex := 0;
      cbxSortByChange(Sender);
    end // DataBaseMode = dbVistA
  else
    // Off line settings
    begin

      cbxOrderedBy.Text := '';
      cbxInterviewer.Text := '';
      cbxLocation.text := '';
      cbxConsult.Text := '';
      grpOrderer.Visible := false;
      grpInterview.Visible := false;
      grpLocation.Visible := false;
      grpConsult.Visible := False;

      mnuMetric.Enabled := false;
      mnuBattery.Enabled := false;
      mnuOnLineSupport.Enabled := false;
      mnuInstrumentDescription.Enabled := false;
      mnuDescription.Enabled := False;

      cbxSortBy.Items.Clear;
      cbxSortBy.Items.Add(ALL);
      cbxSortBy.Items.Add(RESTARTABLE);
      cbxSortBy.ItemIndex := 0;
      DisplayEverything;
    end;

  if not LocalFiles.Check_DLL_Version then // Does YS_MHA_AUX.dll exist on PC? Is it current?
  begin
    
    Halt;
  end;

  lstChosen.Items.Clear;
  // DisplayEverything; This gets hit when the Orderer's name is set.

  // If there are incomplete instruments. DisplayEverything,
  // will load Administration, thus it may need to be reset.
  Administration_OPS.ClearAdmin(lvAdministration);

  // This is not reset in lvAdministration.Clear
  lvAdministration.DateGiven := Now;

  // Off-line: the User.DUZ is set to
  // Name: Off-line, DUZ = No_ID.
  lvCurrentOrdererDUZ := ThisUser.DUZ;
  lvAdministration.Orderer.DUZ := ThisUser.DUZ;
  lvAdministration.AdministeredBy := ThisUser.DUZ;

   //Initialize DateTime variables that need it
  if lvAdministration.DateGiven > 0 then // a previous date exists
    dtpkAdministration.Date := lvAdministration.DateGiven
  else
    begin
      dtpkAdministration.Date := Date;
      lvAdministration.DateGiven := dtpkAdministration.DateTime;
    end;

  //? XE3 migration llh; moved to formShow due to exception error
  //dtpkAdministration.MaxDate := Date ; //Now;

  //patch 129 508 changes llh -- moved ConfigureForm from FormShow to here
  ConfigureForm(sender);

end;


procedure TfrmMHA_InstrumentSelect.FormShow(Sender: TObject);
begin
  //patch 129 508 changes llh -- moved ConfigureForm to FormCreate
  //ConfigureForm(Sender);

  //? XE3 migration llh; moved to formShow due to exception error
  dtpkAdministration.MaxDate := Date ; //Now;

  IsSecureDesktopAvailable := IsSecureDesktopInstalled;
  UpdateButtons;
  lvInitialize := False;

  Screen.Cursor := crDefault;
  frmMHA_Main.Hide;

  //patch 129 508 changes llh - replaced with code below
{  if (DataBaseMode = dbVistA) then
    begin
      if gvUseScreenReader then
        ActiveControl := grpOrderer
      else
        ActiveControl := cbxOrderedBy
    end
  else
    begin
      if gvUseScreenReader then
        ActiveControl := grpDate
      else
        ActiveControl := dtpkAdministration;
    end;
}

  //patch 129 508 changes llh
  if gvUseScreenReader then
    begin
      imgbackup.Visible := false;
      lblPatient.Visible := false;
      lblHeader.Visible := false ;
      pnlHeader.TabStop := true ;
      lblPatientScrRdr.TabStop := true ;
      lblPatientScrRdr.TabOrder := 0;
      lblPatientScrRdr.Caption := lblHeader.Caption + #13 + lblPatient.Caption ;
      lblPatientScrRdr.Visible := true;
      btnScrRdrExit.Visible := true ;
      activeControl := lblPatientScrRdr;
    end
  else
    begin
      imgbackup.Visible := true;
      lblPatient.Visible := true;
      lblHeader.Visible := true ;
      lblPatientScrRdr.TabStop := false ;
      btnScrRdrExit.Visible := false ;
      lblPatientScrRdr.Visible := false;
      if (DataBaseMode = dbVistA) then ActiveControl := cbxOrderedBy
        else ActiveControl := dtpkAdministration;
    end;
end;


procedure TfrmMHA_InstrumentSelect.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin

  gvSelectWidth := Width;
  gvSelectHeight := Height;

  gvShowAllOrOneItem := rbAllAtOnce.Checked;

  if (DataBaseMode = dbOffLine) then
    begin
      if lvShowOffLinePrompt and
        (lstChosen.Items.Count > 0) then
        begin
          MsgDlgFrm('The next time you are connected to VistA, you will be prompted ' +
            'to upload the answers to any instruments administered during this session.',
            MHA_Caption, mtInformation, [mbOK], 0);
          lvShowOffLinePrompt := False;
        end;
    end
  else
    begin // Vista
      if cbxLocation.Text <> '' then
        gvLastLocation := lvAdministration.LocationIEN + U + cbxLocation.Text;
          // IEN^Location
      frmMHA_Main.Visible := True;
    end;

  MHA_Registry.SaveRegistry;
  Action := caFree;

end;


procedure TfrmMHA_InstrumentSelect.FormDestroy(Sender: TObject);
begin
  lvtreSelectItems.Free;
  lvInstrumentHint.Free;

//  if lvAdministration <> nil then
  lvAdministration.Free;

//  if Instrument_OPS.ListOfInstruments <> nil then
//    Instrument_OPS.ListOfInstruments.Free;
end;


procedure TfrmMHA_InstrumentSelect.ConfigureForm(Sender: TObject);
const
  Spacer                      : string = '           '; // 11 blank spaces
begin

  MHA_Registry.ReadRegistry;

  Caption := MHA_Caption + ' in use by ' + ThisUser.Name;

  if gvUseScreenReader then
    begin
      mnuBattery.Visible := false;
      lblSort.Visible := false;
      cbxSortBy.Visible := false;
      pnlSort.Visible := false;
      treSelect.Visible := false;
      treSelect.Images := nil;
      btnUp.Visible := false;
      btnDown.Visible := false;
      btnRemove.Visible := false;
      grpChosen.Visible := false;
      pnlAction.Visible := false;
      grpInstructions.Visible := false;
      lbSelect.Visible := true;
    end
  else
    begin
      lbSelect.Visible := false;
      LoadImageLists;
      mnuBattery.Visible := true;
      lblSort.Visible := true;
      cbxSortBy.Visible := true;
      pnlSort.Visible := true;
      treSelect.Visible := true;
      btnUp.Visible := true;
      btnDown.Visible := true;
      btnRemove.Visible := true;
      grpChosen.Visible := true;
      pnlAction.Visible := true;
      grpInstructions.Visible := true;
    end;

  with GUI_Control do
    begin
      Scaled := True;
      AutoScroll := False;
      AutoSize := False;
      PixelsPerInch := 120;
      KeyPreview := True;
      HorzScrollBar.Range := 0; // Ensures that buttons will move when re-sized
      VertScrollBar.Range := 0;
      lblPatient.Font.Assign(gvFont);

      // The screen dimensions are set to the user's last setting.
      Height := GetHeight(gvSelectHeight);
      Width := GetWidth(gvSelectWidth);
      Left := GetLeft(Width);
      Top := GetTop(Height);
      if CheckWidth(Width) or CheckHeight(Height) then
        WindowState := wsMaximized;
      //patch 129 508 changes llh -- see if this stops the header from being read 2x
      Refresh; // resets alClient dimensions

      pnlRight.Width := TextWidth('One Question at a Time XX', gvFont) +
        ButtonWidth('Patient Entry') + 30;
      pnlLeft.Width := 3 * ButtonWidthNormal;
      pnlActionRight.Width := ButtonWidth('Patient Entry') + 5;
      pnlAction.Height := 4 * ButtonHeight;

      btnPatientEntry.Font.Assign(gvFont);
      btnPatientEntry.Height := ButtonHeight;
      btnPatientEntry.Width := ButtonWidth('Patient Entry');
      btnPatientEntry.Left := 1;
      btnPatientEntry.Top := 2 * ButtonHeight div 3;

      btnStaffEntry.Font.Assign(gvFont);
      btnStaffEntry.Height := ButtonHeight;
      btnStaffEntry.Width := btnPatientEntry.Width;
      btnStaffEntry.Left := btnPatientEntry.Left;
      btnStaffEntry.Top := 7 * ButtonHeight div 3;

      lblDisplay.Font.Assign(gvFont);
      lblDisplay.Top := pnlAction.Height div 7;
      lblDisplay.Left := (pnlAction.Width div 4) -
        (TextHeight(lblDisplay.Caption, gvFont) div 2);

      rbOneAtATime.Font.Assign(gvFont);
      rbOneAtATime.Left := 5;
      rbOneAtATime.Width := pnlRadio.Width;
      rbOneAtATime.Height := TextHeight('Yy', gvFont);
      rbOneAtATime.Top := (pnlAction.Height div 2) - rbOneAtATime.Height;

      rbAllAtOnce.Font.Assign(gvFont);
      rbAllAtOnce.Left := rbOneAtATime.Left;
      rbAllAtOnce.Width := rbOneAtATime.Width;
      rbAllAtOnce.Height := rbOneAtATime.Height;
      rbAllAtOnce.Top := pnlAction.Height - (pnlAction.Height div 7) -
        rbOneAtATime.Height;

      rbAllAtOnce.Checked := gvShowAllOrOneItem;
      rbOneAtATime.Checked := not gvShowAllOrOneItem;

      pnlHeader.Height := pnlHeaderHeight;
      lblHeader.Font.Size := lblHeaderFontSize;

      lblInstructions.Font.Assign(gvFont);
      lblInstructions.Font.Color := clNavy;
      grpInstructions.Font.Assign(gvFont);
      grpInstructions.Font.Color := clNavy;

      grpOrderer.Height := 2 * ButtonHeight;
      grpDate.Height := grpOrderer.Height;
      grpInterview.Height := grpOrderer.Height;
      grpLocation.Height := grpOrderer.Height;

      grpConsult.Height := grpOrderer.Height;
      cbxOrderedBy.Top := 2 * ((grpOrderer.Height - cbxOrderedBy.Height) div 3);
      cbxInterviewer.Top := cbxOrderedBy.Top;
      dtpkAdministration.Top := cbxOrderedBy.Top;
      cbxLocation.Top := cbxOrderedBy.Top;
      cbxConsult.Top := cbxOrderedBy.Top;
      lblSort.Top := (pnlSort.Height - cbxSortBy.Height) div 2;
      cbxSortBy.Top := (pnlSort.Height - cbxSortBy.Height) div 2;

      lblPatient.Font.Size := lblPatientFontSize;
      lblPatient.Caption := Patient.CaptionInfo;

      lblHeader.Caption := HEADERCAPTION;
      lblHeader.Font.Size := lblHeaderFontSize;
    end;

  if gvUseScreenReader then
    begin
      Left := 0;
      Width := Screen.Width;
      imgBackup.Visible := False;
      Caption := 'Select instrument for patient ' + Patient.Name;
      grpOrderer.Caption := 'Instrument &Ordered by: vista combo box.';
      grpInterview.Caption := '&Interviewer: vista combo box.';
      grpLocation.Caption := 'Visit &Location: vista combo box.';
      grpConsult.Caption := 'Link with Consult: vista combo box.';
      grpDate.Caption := '&Date of Administration:';
      grpAvailable.Caption := '&Available Instruments. ' +
      // patch 129 llh - hint indicates to use the Space bar but code checks for Return key, changed to return key
      //'Navigate with arrow keys and use space bar to select the desired ' +
        'Navigate with arrow keys and use the Enter key to select the desired ' +
        'instruments. Initially no instruments are selected. Use ALT C to leave ' +
        'this section.';

      pnlRadio.Visible := False;
      gvShowAllOrOneItem := true;

      //btnPatientEntry.caption := btnPatientEntry.Caption + ' button';
      //btnStaffEntry.caption := btnStaffEntry.Caption + ' button';

      // Needed for JAWS to read the captions
      grpOrderer.TabStop := True;
      grpInterview.TabStop := True;
      grpLocation.TabStop := True;
      grpConsult.TabStop := True;
      grpDate.TabStop := True;
      grpAvailable.TabStop := True;
    end;

end;

//------------------------------------------------------------------------------
//            Buttons
//------------------------------------------------------------------------------

procedure TfrmMHA_InstrumentSelect.btnPatientEntryClick(Sender: TObject);
var
  tmpMsg                      : string;
  UserCancels                 : boolean;
begin
  if (cbxLocation.ItemIndex = -1) and (DataBaseMode = dbVista) then
    begin
      MessageDlg('Please select a Visit Location before proceeding.', mtError,
        [mbOK], 0);
      exit;
    end;

  { TODO 2 -oRDF : The first test of this IF statement will always be false,
   because the button triggering this event is disabled if SD is not available }
  if not IsSecureDesktopAvailable then
    begin
      tmpMsg := 'The security program that must be used to test patients '
        + 'on-line cannot be found.  MHA can be used only for staff-entry of '
        + 'answers.' + CRLF + CRLF
        + 'Do you want to continue?';
      if MsgDlgFrm(tmpMsg, MHA_Caption, mtWarning, [mbYes, mbNo], 0) = mrYes then
        begin
          btnStaffEntryClick(Sender);
          Exit;
        end
      else
        exit;
    end
  else
    // Security Program is operational
    begin
      frmMHA_SD_Warning := TfrmMHA_SD_Warning.Create(nil);
      try
        frmMHA_SD_Warning.lblNotice.Caption := CRLF +
          'From this point on, the veteran will be answering questions on the ' +
          'instruments selected. To maintain security, all other functions on ' +
          'this computer will be unavailable.' + CRLF + CRLF +
          'All unsaved work in other programs should be saved and the programs ' +
          'closed before continuing.' + CRLF + CRLF +
          'AFTER COMPLETING THE TEST(S), USER IS AUTOMATICALLY LOGGED OFF THE ' +
          'SYSTEM' + CRLF + CRLF +
          'Do you wish to continue?';

        frmMHA_SD_Warning.ShowModal;

        UserCancels := frmMHA_SD_Warning.ModalResult = mrCancel;
      finally
        frmMHA_SD_Warning.free;
      end;

      if UserCancels then
        exit;

      Proctor.DataEntryMode := emPatient;

      Startva_SecureDesktop;

    end;

  DisplaySelectedInstruments;

end;

procedure TfrmMHA_InstrumentSelect.btnStaffEntryClick(Sender: TObject);
begin
  if (cbxLocation.ItemIndex = -1) and (DataBaseMode = dbVista) then
    begin
      MessageDlg('Please select a "Visit Location" before proceeding.', mtError,
        [mbOK], 0);
      Exit;
    end;

  Proctor.DataEntryMode := emStaff;

  DisplaySelectedInstruments;

end;

procedure TfrmMHA_InstrumentSelect.SendEMailToOrderer;
var
  i                           : Integer;
  TempStr,
    Reply                     : string;
begin

  if not (DatabaseMode = dbVista) then
    Exit;

  for i := 0 to Administration_OPS.Administrations.Count - 1 do
    TempStr := TempStr +
      TAdministration(Administration_OPS.Administrations[i]).InstrumentName + ', ';

  Delete(TempStr, Length(TempStr) - 2, 2); // remove last comma

  Reply := Administration_OPS.NotifyOrderer(lvCurrentOrdererDUZ, Patient.DFN, TempStr); // uMHA_Administration

  if (Reply = OK) then
    Exit;

  Reply := 'MHA was unable to notify ' + cbxOrderedBy.Text + ' of this test '
    + 'session.  Please do so yourself.' + CRLF + CRLF + Reply;

  MsgDlgFrm(Reply, MHA_Caption, mtWarning, [mbOK], 0);

end;

procedure TfrmMHA_InstrumentSelect.DisplaySelectedInstruments;
begin
  Screen.Cursor := crHourGlass;
  gvPass := '';

  if (cbxOrderedBy.Items.Count = 0) then
    lvAdministration.OrdererDUZ := ThisUser.DUZ
  else
    lvAdministration.OrdererDUZ :=
      IntToStr(cbxOrderedBy.ItemIEN);

  BuildListOfSelectedInstruments;

  if Proctor.DataEntryMode = emStaff then
    SendEMailToOrderer;

  Hide;

  if gvShowAllOrOneItem then
    begin
      try
        frmMHA3_AdministerAllItems := TfrmMHA3_AdministerAllItems.Create(nil);
      finally
        frmMHA3_AdministerAllItems.Free;
      end;

      lvShowOffLinePrompt := (gvPass <> 'CANCEL');
      Close;
    end
  else
    begin
      try
        frmMHA3_AdministerSingleItems :=
          TfrmMHA3_AdministerSingleItems.Create(nil);
      finally
        frmMHA3_AdministerSingleItems.Free;
      end;

      lvShowOffLinePrompt := (gvPass <> 'CANCEL');
      Close;
    end;

end;

procedure TfrmMHA_InstrumentSelect.UpdateButtons;
begin
  if lstChosen.Items.Count <= 0 then
    begin
      btnStaffEntry.Enabled := False;
      btnPatientEntry.Enabled := False;
    end
  else
    begin
      btnPatientEntry.Enabled := IsSecureDesktopAvailable;
      btnStaffEntry.Enabled := True;
    end;

  if lstChosen.Items.Count > 1 then
    begin
      btnUp.Enabled := true;
      btnDown.Enabled := true;
    end
  else
    begin
      btnUp.Enabled := False;
      btnDown.Enabled := False;
    end;

  if lstChosen.SelCount > 0 then
    btnRemove.Enabled := true
  else
    btnRemove.Enabled := false;
end;

procedure TfrmMHA_InstrumentSelect.btnRemoveClick(Sender: TObject);
var
  i                           : Integer;
  TempCaption                 : string;
begin
  TempCaption := lstChosen.Selected.Caption;

  i := lstChosen.Items.IndexOf(lstChosen.Selected);
  lstChosen.Items.Delete(i);

  if gvUseScreenReader then
    ScreenReaderUnCheckThisOne(TempCaption)
  else
    treSelectUnCheckThisNode(TempCaption);

  UpdateButtons;
end;

procedure TfrmMHA_InstrumentSelect.btnUpClick(Sender: TObject);
var
  i                           : Integer;
  tempstr                     : string;
begin
  for i := 1 to lstChosen.Items.Count - 1 do
    if lstChosen.Items[i].Selected then
      begin
        tempstr := lstChosen.Items[i - 1].Caption;
        lstChosen.Items[i - 1].Caption := lstChosen.Items[i].Caption;
        lstChosen.Items[i].Caption := tempstr;
        break;
      end;
  ActiveControl := lstChosen;
  if i < 2 then
    lstChosen.Items[0].Selected := True
  else
    lstChosen.Items[i - 1].Selected := True;
end;

procedure TfrmMHA_InstrumentSelect.btnDownClick(Sender: TObject);
var
  i                           : Integer;
  tempstr                     : string;
begin
  for i := 0 to lstChosen.Items.Count - 2 do
    if lstChosen.Items[i].Selected then
      begin
        tempstr := lstChosen.Items[i + 1].Caption;
        lstChosen.Items[i + 1].Caption := lstChosen.Items[i].Caption;
        lstChosen.Items[i].Caption := tempstr;
        break;
      end;
  ActiveControl := lstChosen;
  if i > lstChosen.Items.Count - 2 then
    Exit;
  lstChosen.Items[i + 1].Selected := True;
end;

function TfrmMHA_InstrumentSelect.GetInstrumentDetails(aInstrumentName: string): string;
begin
// Yields string with DaysToRestart: integer (Range is -1 to 99
//  where -1 is no limit, 0 is not allowed) ^
// GenerateProgNote: Boolean ^
// ProgNoteTitle: string
// ConsultNoteTitle: string

  Result := Instrument_OPS.ReadInstrumentDetails(aInstrumentName);
end;


function CleanupText(TextIn: string): string;
// Removes date from instrument string
var
  i                           : Integer;
begin
  Result := TextIn;
  i := Pos('(', TextIn);
  if i > 0 then
    begin
      Delete(Result, i - 2, Length(TextIn) - i + 3);
      Trim(Result);
    end;
end;


function CaptionToDate(ACaption: string): string;
begin
  Result := Trim(Piece(Piece(ACaption, '(', 2), ')', 1));
end;

procedure TfrmMHA_InstrumentSelect.BuildListOfSelectedInstruments;
var
  TempStr,
    TempDetails               : string;
  TempDate                    : TDateTime;
  i                           : Integer;
  IsRestarted                 : BOOLEAN;
  TempAdmin                   : TAdministration;

  function CheckOutInstrument(Str: string): Boolean;
  var
    ii                        : Integer;
  begin
    result := False;
    for ii := 0 to Instrument_OPS.ListOfInstruments.Count - 1 do
      if Str = Trim(TAvailableInstrument(Instrument_OPS.ListOfInstruments[ii]).AvailInstrumentName) then
        begin
          result := true;
          break;
          Exit;
        end;
  end;

begin
  TempStr := '';
  TempDetails := '';
  i := -1;

  Administration_OPS.Administrations.Clear;

  while i < lstChosen.Items.Count - 1 do
    begin
      Inc(i);
      TempStr := lstChosen.Items[i].Caption;

      IsRestarted := pos('(', TempStr) > 0;

      // Sometimes an instrument might sneak into this list, via a battery most
      // likely, that is not on the user's list of available instruments.
      if not IsRestarted then
        if not CheckOutInstrument(Trim(TempStr)) then
          begin
            Continue;
            TempStr := lstChosen.Items[i].Caption;
            IsRestarted := pos('(', TempStr) > 0;
          end;

      TempAdmin := TAdministration.Create;

      if IsRestarted then
        begin
          TempDate := StrToDateTime(CaptionToDate(TempStr));
          TempAdmin.InstrumentName := CleanupText(TempStr); //Test name
          TempAdmin.ID := Administration_OPS.GetAdminID(TempAdmin.InstrumentName, TempDate);
        end
      else
        begin
          TempAdmin.InstrumentName := TempStr;
          TempAdmin.ID := NO_ID;
        end;

      TempAdmin.NumberAnswered := 0;
      TempAdmin.NumberSkipped := 0;
      TempAdmin.NumberStillRequired := 0;

      TempDetails := GetInstrumentDetails(TempStr);
      TempAdmin.DaysToRestart := StrToIntDef(Piece(TempDetails, U, 1), 2);
      TempAdmin.GenerateProgNote := StrToBool(Piece(TempDetails, U, 2));
      TempAdmin.ProgNoteTitle := Piece(TempDetails, U, 3);
      TempAdmin.ConsultTitle := Piece(TempDetails, U, 4);

      TempAdmin.RecordID := NO_ID;
      TempAdmin.PatientID := Patient.DFN;
      TempAdmin.Signed := False;

      TempAdmin.DateSaved := Now;
      TempAdmin.DateGiven := lvAdministration.DateGiven;
      TempAdmin.IsComplete := False;
      TempAdmin.IsRestartable := False;

      TempAdmin.OrdererDUZ := lvAdministration.OrdererDUZ;
      TempAdmin.Orderer.DUZ := lvAdministration.Orderer.DUZ;
      TempAdmin.AdministeredBy := lvAdministration.AdministeredBy;
      TempAdmin.LocationIEN := lvAdministration.LocationIEN;
      TempAdmin.LocationStr := lvAdministration.LocationStr;
      TempAdmin.ConsultIEN := lvAdministration.ConsultIEN;

      Administration_OPS.Administrations.Add(TempAdmin);
    end;

end;

//------------------------------------------------------------------------------
//              Menu controls
//------------------------------------------------------------------------------



procedure TfrmMHA_InstrumentSelect.mnuSelectPatientClick(Sender: TObject);
var
  Save_Cursor                 : TCursor;
begin
  if (DataBaseMode = dbVista) then
    begin
      Save_Cursor := Screen.Cursor;
      Screen.Cursor := crHourglass; { Show hourglass cursor }
      try
        Patient_OPS.SelectUsingCPRS;
      finally
        Screen.Cursor := Save_Cursor; { Always restore to normal }
      end; //try
    end //dbVista
  else
   // Off-line administration needs to close this form.
    Close;

end;

procedure TfrmMHA_InstrumentSelect.mnuDescriptionClick(Sender: TObject);
var
  Data                        : PSelectData;
  aInstrument                 : TInstrument;
  aAdmin                      : TAdministration;
  TempDate                    : TDateTime;
  TempStr                     : string;
  i                           : Integer;
begin

  if treSelect.SelectedCount < 1 then
    begin
      MsgDlgFrm('No instrument identified.' + #13 +
        'Select an instrument by clicking on it.',
        MHA_Caption, mtInformation, [mbOK], 0);
      exit;
    end;

  Data := treSelect.GetNodeData(treSelect.GetFirstSelected);

  if Data.Style = 'B' then // right click on Battery
    Exit;

  // Show incomplete administration report
  if Pos('(', Data^.Caption) > 0 then
    begin
      aAdmin := TAdministration.Create;

      TempDate := StrToDateTime(CaptionToDate(Data^.Caption));
      TempStr := CleanupText(Data^.Caption); //Test name

      for i := 0 to Administration_OPS.ListOfIncompletes.Count - 1 do
        begin
          if (TAdministration(Administration_OPS.ListOfIncompletes[i]).InstrumentName = TempStr) and
            (TAdministration(Administration_OPS.ListOfIncompletes[i]).DateGiven = TempDate) then
            begin
              aAdmin := TAdministration(Administration_OPS.ListOfIncompletes[i]);
              break;
            end;
        end; // for i

      if aAdmin.ID = '' then
        begin
          aAdmin.Free;
          Exit;
        end;

      try
        frmMHA_InstrumentDescription := TfrmMHA_InstrumentDescription.Create(nil);
        frmMHA_InstrumentDescription.ShowIncompleteAdministration(aAdmin);
        frmMHA_InstrumentDescription.ShowModal;
      finally
        frmMHA_InstrumentDescription.Free;
        aAdmin.Free;
      end;
    end
  else
    // Show Instrument description
    begin

      aInstrument := TInstrument.Create;
      aInstrument.InstrumentName := Data^.Caption;

      if Instrument_OPS.LoadDescriptiveProperties(aInstrument) then
        begin
          try
            frmMHA_InstrumentDescription := TfrmMHA_InstrumentDescription.Create(nil);
            frmMHA_InstrumentDescription.ShowDescription(aInstrument);
            frmMHA_InstrumentDescription.ShowModal;
          finally
            frmMHA_InstrumentDescription.Free;
            aInstrument.Free;
          end;
        end //if instrument descriptive properties loaded
      else
        aInstrument.Free;
    end;
end;

procedure TfrmMHA_InstrumentSelect.mnuOptionsClick(Sender: TObject);
begin
  if gvUseScreenReader then
    begin
      try
        frmMHA_Options_508 := TfrmMHA_Options_508.Create(nil);
      finally
        frmMHA_Options_508.Free;
      end;

    end
  else
    begin
      gvShowOptionTabs := '012'; // Show tab 0 on options form, Fonts

      try
        frmMHA_Options := TfrmMHA_Options.Create(nil);
      finally
        frmMHA_Options.Free;
      end;

      if GUI_Control.NeedGUIUpdate then
        begin
          ConfigureForm(Sender);
          DisplayEverything;
        end;
    end;
end;

procedure TfrmMHA_InstrumentSelect.mnuBatteryClick(Sender: TObject);
var
  Redraw                      : boolean;
begin
  // In case InstrumentDescription is begun from BatteryWizard,
  // Administration needs to be cleared here.
  Administration_OPS.ClearAdmin(lvAdministration);
  // This is not reset in lvAdministration.Clear
  lvAdministration.DateGiven := Now;

  //redraw := False;
  // Hide InstrumentSelect while BatteryWizard is in use.
  Visible := false;

  try
    frmMHA_BatteryWizard := TfrmMHA_BatteryWizard.Create(nil);
    redraw := frmMHA_BatteryWizard.Change;
  finally
    frmMHA_BatteryWizard.Free;
    Visible := True;
  end;

  // User may have changed fonts in Batt Wizard
  if GUI_Control.NeedGUIUpdate then
    begin
      ConfigureForm(Sender);
      DisplayEverything;
    end;

  // Redraw InstrumentSelect if user makes changes in Battery form
  if Redraw then
    begin
      Battery_OPS.LoadBatteries;

      // Redraw the lists of instruments & batteries
      if cbxSortBy.text = BATTERY then
        DisplayBatteries
      else
        DisplayEverything;
    end;
end;


procedure TfrmMHA_InstrumentSelect.NewPatientDisplay;
begin
  PrepareListOfIncompletes;
  DisplayEverything;
  lblPatient.Caption := Patient.CaptionInfo;
  lblPatient.Update;
end;

procedure TfrmMHA_InstrumentSelect.ScreenReaderDisplayEverything;
// JAWS will not read the checked status of the TreeView, nor checkLists.
// It does fine with list boxes.
var
  TempStr                     : string;
    i                         : integer;


begin
  lbSelect.Items.clear;

  // List the incompletes
  if Administration_OPS.ListOfIncompletes.Count > 0 then
    begin
      for i := 0 to Administration_OPS.ListOfIncompletes.Count - 1 do
        with TAdministration(Administration_OPS.ListOfIncompletes[i]) do
          if Orderer.DUZ = lvCurrentOrdererDUZ then
            TempStr := Tempstr + InstrumentName +
              '  (' + DateTimeToStr(DateGiven) + ')' + U;
    end;

  // List of instruments
  for i := 0 to Instrument_OPS.ListOfInstruments.Count - 1 do
    TempStr := TempStr + TAvailableInstrument(Instrument_OPS.ListOfInstruments[i]).AvailInstrumentName + U;

  for i := 1 to NumberOfPieces(TempStr, U) - 1 do
    lbSelect.Items.add(Piece(TempStr, U, i));

end;

procedure TfrmMHA_InstrumentSelect.ScreenReaderUnCheckThisOne(ThisOne: string);
// This is used to uncheck a given instrument when it is dropped from the
// list of selected instruments when a screen reader is in use.
var

  i                           : Integer;
begin

  for i := 0 to ComponentCount - 1 do
    begin
      if Components[i] is TCheckBox then
        with TCheckBox(Components[i]) do
          if Caption = ThisOne then
            begin
              Checked := false;
              break;
            end;

    end; // for i
end;


procedure TfrmMHA_InstrumentSelect.DisplayEverything;
var
  i, j                        : Integer;
  TempStr                     : string;
begin
  if gvUseScreenReader then
    begin
      ScreenReaderDisplayEverything;
      Exit;
    end;

  lvNodeHeight := 3 * GUI_Control.TextHeight('Yy', gvFont) div 2;
  treSelect.Colors.FocusedSelectionColor := clHighlight;
  treSelect.Colors.UnfocusedSelectionColor := clBtnFace;
  treSelect.Font.Assign(gvFont);
  treSelect.DefaultNodeHeight := lvNodeHeight;
  treSelect.Clear;

  lvtreSelectItems.Clear;
  lvRootNode := 0; // The first node in lvtreSelectItems;

  grpAvailable.Caption := ' &Available Instruments and Batteries:  ';

  // All instruments, incompletes and batteries are in root,
  // with batteries having a sub-level

  TempStr := 'Root=';

  // List the incompletes
  if Administration_OPS.ListOfIncompletes.Count > 0 then
    begin
      for i := 0 to Administration_OPS.ListOfIncompletes.Count - 1 do
        with TAdministration(Administration_OPS.ListOfIncompletes[i]) do
          if Orderer.DUZ = lvCurrentOrdererDUZ then
            TempStr := Tempstr + InstrumentName +
              '  (' + DateTimeToStr(DateGiven) + ')' + U;
    end;

  // The battery info is stored in Vista. No batteries for off-line
  if (DataBaseMode = dbVistA) then
    begin
      if (Battery_OPS.ListOfBatteries.Count > 0) then
        begin
          for i := 0 to Battery_OPS.ListOfBatteries.Count - 1 do
            TempStr := TempStr + TBattery(Battery_OPS.ListOfBatteries[i]).BatteryName + U;
        end;
    end;

  // List of instruments
  for i := 0 to Instrument_OPS.ListOfInstruments.Count - 1 do
    TempStr := TempStr + TAvailableInstrument(Instrument_OPS.ListOfInstruments[i]).AvailInstrumentName + U;

  lvtreSelectItems.Add(TempStr);

  // Second level of instruments for a battery
  if (DataBaseMode = dbVistA) then
    begin
      TempStr := '';
      if (Battery_OPS.ListOfBatteries.Count > 0) then
        begin
          for i := 0 to Battery_OPS.ListOfBatteries.Count - 1 do
            begin
              TempStr := TBattery(Battery_OPS.ListOfBatteries[i]).BatteryName + '=';

              for j := 0 to TBattery(Battery_OPS.ListOfBatteries[i]).InstrumentsInBattery.Count - 1 do
                TempStr := TempStr +
                  Piece(TBattery(Battery_OPS.ListOfBatteries[i]).InstrumentsInBattery[j], U, 3) + U;
              lvtreSelectItems.Add(TempStr);
            end; // Battery count
        end;
    end; // Vista

  // treSelect needs to know the number of root items. Put root items first in
  // lvtreSelectItems. This statement populates the tree
  treSelect.RootNodeCount := NumberOfPieces(lvtreSelectItems[0], U) - 1;
  treSelect.NodeDataSize := SizeOf(TSelectData);

  // If a new patient is selected in CPRS, we have to re-populate the consult list.
  if (DataBaseMode = dbVistA) then
    begin
      cbxConsult.Items.clear;
      cbxConsult.Items.AddStrings(Consult_OPS.LoadConsultSubSet(Patient.DFN,
        DataModule1.RPCBroker1));
      cbxConsult.DropDownCount := cbxConsult.Items.Count - 1;
    end;
end;


//------------------------------------------------------------------------------
//              Keypress events
//------------------------------------------------------------------------------

procedure TfrmMHA_InstrumentSelect.FormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (Shift = [ssALT]) and (Key = vk_F4) then
    Close;

  if Key = vk_Escape then
    begin
      Close;
      Key := 0;
    end;

  // F1
  if (Key = vk_F1) then
    begin
      mnuDescriptionClick(Self);
      Exit;
    end;
end;

//------------------------------------------------------------------------------
//              Setup Components
//------------------------------------------------------------------------------

procedure TfrmMHA_InstrumentSelect.dtpkAdministrationChange(
  Sender: TObject);
begin
  lvAdministration.DateGiven := dtpkAdministration.DateTime;

end;


//patch 129 llh -- provide validation checking on Date of administration -
//                     must be administered within the last year.
procedure TfrmMHA_InstrumentSelect.dtpkAdministrationExit(Sender: TObject);
var
  compareDate : TDateTime;
begin
  compareDate := Now ;
  compareDate := IncYear(compareDate, -1) ;

  if dtpkAdministration.Date >= compareDate then exit ;

  MsgDlgFrm('The date of administration must be within the last year.', MHA_Caption, mtWarning, [mbOK], 0);
  dtpkAdministration.Date := Now ;
  dtpkAdministration.SetFocus ;
end;

procedure TfrmMHA_InstrumentSelect.cbxSortByChange(Sender: TObject);
begin
  if cbxSortBy.Text = ALL then
    DisplayEverything;
  if cbxSortBy.Text = BATTERY then
    DisplayBatteries;
  if cbxSortBy.Text = RESTARTABLE then
    DisplayReStartables;
end;

procedure TfrmMHA_InstrumentSelect.PrepareListOfIncompletes;
begin
  Administration_OPS.ListOfIncompletes.Clear;
  Administration_OPS.ReadIncompleteResults(Patient.DFN, lvCurrentOrdererDUZ);
  // This will add crash files to list of Incompletes
  LocalFiles.CrashFileExists(Patient.DFN, lvCurrentOrdererDUZ);
end;


procedure TfrmMHA_InstrumentSelect.DisplayReStartables;
var
  i                           : integer;
  TempStr                     : string;
begin
  treSelect.Colors.FocusedSelectionColor := clHighlight;
  treSelect.Colors.UnfocusedSelectionColor := clBtnFace;
  treSelect.Font.Assign(gvFont);
  treSelect.DefaultNodeHeight := lvNodeHeight;
  treSelect.Clear;
  lvtreSelectItems.Clear;
  lvRootNode := 0; // The first node in lvtreSelectItems;

  grpAvailable.Caption := ' &Available Incomplete:  ';

  TempStr := 'Root=';

  if Administration_OPS.ListOfIncompletes.Count = 0 then
    TempStr := 'Root=None';

  for i := 0 to Administration_OPS.ListOfIncompletes.Count - 1 do
    with TAdministration(Administration_OPS.ListOfIncompletes[i]) do
      begin
        if Orderer.DUZ = lvCurrentOrdererDUZ then
          TempStr := Tempstr + InstrumentName +
            '  (' + DateTimeToStr(DateGiven) + ')' + U;
      end;

  lvtreSelectItems.Add(TempStr);

  // treSelect needs to know the number of root items. Put root items first in
  // lvtreSelectItems. This statement populates the tree
  treSelect.RootNodeCount := NumberOfPieces(lvtreSelectItems[0], U) - 1;
  treSelect.NodeDataSize := SizeOf(TSelectData);
end;

procedure TfrmMHA_InstrumentSelect.DisplayBatteries;
var
  i, j                        : integer;
  TempStr                     : string;
begin
  lvtreSelectItems.Clear;
  treSelect.Clear;

  if (DataBaseMode <> dbVistA) or
    (Battery_OPS.ListOfBatteries.Count = 0) then
    Exit;

  treSelect.Colors.FocusedSelectionColor := clHighlight;
  treSelect.Colors.UnfocusedSelectionColor := clBtnFace;
  treSelect.Font.Assign(gvFont);
  treSelect.DefaultNodeHeight := lvNodeHeight;

  lvRootNode := 0; // The first node in lvtreSelectItems;

  grpAvailable.Caption := ' &Available Batteries:  ';

  TempStr := 'Root=';

  for i := 0 to Battery_OPS.ListOfBatteries.Count - 1 do
    TempStr := TempStr + TBattery(Battery_OPS.ListOfBatteries[i]).BatteryName + U;

  lvtreSelectItems.Add(TempStr);

  for i := 0 to Battery_OPS.ListOfBatteries.Count - 1 do
    begin
      TempStr := TBattery(Battery_OPS.ListOfBatteries[i]).BatteryName + '=';

      for j := 0 to TBattery(Battery_OPS.ListOfBatteries[i]).InstrumentsInBattery.Count - 1 do
        TempStr := TempStr +
          Piece(TBattery(Battery_OPS.ListOfBatteries[i]).InstrumentsInBattery[j], U, 3) + U;
      lvtreSelectItems.Add(TempStr);
    end;
  //This statement populates the tree
  treSelect.RootNodeCount := NumberOfPieces(lvtreSelectItems[0], U) - 1;
  treSelect.NodeDataSize := SizeOf(TSelectData);
end;


function TfrmMHA_InstrumentSelect.InstrumentAllowed(WhichOne: string): boolean;
// Off-line check for YS_MHA_AUX.dll
var
  TempInstrument              : TInstrument;
  RequiredVersion,
    LoadedVersion             : string;
  i,
    RequiredVersionInt,
    PCVersionInt              : integer;
begin
  result := true;

  TempInstrument := TInstrument.Create;

  // Load instrument object from resource file.
  ResourceFile_OPS.ReadResourceFile(TempInstrument);

  if TempInstrument.DLL_Version <> '' then
    begin
      RequiredVersion := TempInstrument.DLL_Version;
      for i := 1 to 4 do
        begin
          RequiredVersionInt := StrToIntDef(Piece(RequiredVersion, '.', i), 0);
          PCVersionInt := StrToIntDef(Piece(LoadedVersion, '.', i), 0);

          if RequiredVersionInt > PCVersionInt then
            begin
              ShowMessage('An important file needs to be updated. ' + #13#13 +
                'YS_MHA_AUX.dll is used by MHA to handle complex instruments and ' +
                //patch 105 changed to use gvEnvVar to name the directory
                //'it is located in C:\Program Files (x86)\Vista\Common Files. ' + #13#13 +
                'it is located in ' + gvEnvVar +'\Vista\Common Files. ' + #13#13 +
                'The desired version is: ' + RequiredVersion + #13 +
                'Version in use: ' + LoadedVersion + #13#13 +
                'Please contact IRM to have this file updated. MHA will not ' +
                'continue for this instrument.');
              result := false;
              break;
            end;
        end;
    end;

  TempInstrument.Free;


(*  Instrument not used.
  if Pos('PTSD STATUS FORM', UpperCase(WhichOne)) > 0 then
    begin
      MsgDlgFrm(' Sorry, the PTSD Status Form can not be administered off-line. ' +
        'Verified patient information in Vista is required for the PSF.',
        MHA_Caption, mtInformation, [mbOK], 0);
      result := false;
    end;
*)
end;


procedure TfrmMHA_InstrumentSelect.lstChosenRedundant;
var
  i, j                        : Integer;
begin
  UpdateButtons;
  for i := 0 to lstChosen.Items.Count - 1 do
    begin
      for j := i + 1 to lstChosen.Items.Count - 1 do
        if CleanupText(lstChosen.Items[i].Caption) =
          CleanupText(lstChosen.Items[j].Caption) then
          begin
        //Assume the last one added is the one to keep?
            lstChosen.Items[i].Delete;
            Break;
          end;
    end;
end;

procedure TfrmMHA_InstrumentSelect.LoadImageLists;

// D2 and D3 image lists are incompatible, thus I load the icons here from the resource.
// BTW. Loading icons this way produces much better looking images in the trees
// than by loading it in the IDE.

var
  Icon                        : TIcon;
  H, W                        : Integer;

begin
  // ImageList1 with predefined icons
  H := ImageList1.Height;
  W := ImageList1.Width;
  Icon := TIcon.Create;

  Icon.Handle := LoadImage(HInstance, 'USERSET', IMAGE_ICON, W, H, 0);
  ImageList1.AddIcon(Icon);
  IconBattery := ImageList1.Count - 1;

  Icon.Handle := LoadImage(HInstance, 'INSTRUMENT', IMAGE_ICON, W, H, 0);
  ImageList1.AddIcon(Icon);
  IconInstrument := ImageList1.Count - 1;

  Icon.Handle := LoadImage(HInstance, 'INCOMPLETE', IMAGE_ICON, W, H, 0);
  ImageList1.AddIcon(Icon);
  IconIncomplete := ImageList1.Count - 1;

  //ImageList1.DrawingStyle := dsNormal;  *KCM*

  Icon.Free;
end;

procedure TfrmMHA_InstrumentSelect.lstChosenExit(Sender: TObject);
begin
  UpdateButtons;
end;

//------------------------------------------------------------------------------
//            Drag and Drop
//------------------------------------------------------------------------------

procedure TfrmMHA_InstrumentSelect.lstChosenDragDrop(Sender,
  Source: TObject; X, Y: Integer);
var
  OldIndex, NewIndex          : integer;
  InsertItem                  : TListItem;
  Old                         : string;
begin
  Old := lstChosen.Selected.Caption;
  OldIndex := lstChosen.Items.IndexOf(lstChosen.Selected);
  NewIndex := lstChosen.Items.IndexOf(lstChosen.GetItemAt(X, Y));
  if NewIndex = -1 then
    NewIndex := lstChosen.Items.Count - 1;
  with Source as TListView do
    begin
      Items.Delete(OldIndex);
      InsertItem := Items.Insert(NewIndex);
      InsertItem.Caption := Old;
    end;
end;

procedure TfrmMHA_InstrumentSelect.lstChosenDragOver(Sender,
  Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if Source is TListView then
    Accept := True;
end;

procedure TfrmMHA_InstrumentSelect.lstChosenMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
    with Sender as TListView do
      BeginDrag(False);
end;


//------------------------------------------------------------------------------
//  Update instructions panel with OnEnter & MouseOver events
//------------------------------------------------------------------------------

procedure TfrmMHA_InstrumentSelect.lblHeaderMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  // Update the instructions panel.
  lblInstructions.Caption := CRLF +
    '  These instructions change depending upon the location of the mouse or cursor.';
end;


procedure TfrmMHA_InstrumentSelect.lstChosenMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  // Update the instructions panel.
  lstChosenEnter(Sender);
end;

procedure TfrmMHA_InstrumentSelect.lstChosenEnter(Sender: TObject);
begin
  // Update the instructions panel.
  lblInstructions.Caption := CRLF +
    '  This is the order in which the instruments ' +
    'will be presented.' + CRLF + CRLF +
    '  Use the arrows to change the order or remove ' +
    'an instrument.';

  UpdateButtons;

end;

procedure TfrmMHA_InstrumentSelect.cbxOrderedByEnter(Sender: TObject);
begin
  // Update the instructions panel.
  lblInstructions.Caption := CRLF +
    '  If you select someone else as the instrument orderer, that person ' +
    'will be notified by e-mail.' + CRLF + CRLF +
    '  Instruments that are available depends on the instrument orderer.';
end;

procedure TfrmMHA_InstrumentSelect.grpOrdererMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  // Update the instructions panel.
  cbxOrderedbyEnter(Sender);
end;

procedure TfrmMHA_InstrumentSelect.grpDateMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  // Update the instructions panel.
  dtpkAdministrationEnter(sender);
end;

procedure TfrmMHA_InstrumentSelect.dtpkAdministrationEnter(
  Sender: TObject);
begin
  // Update the instructions panel.
  lblInstructions.Caption := CRLF +
    '  Enter date instrument was administered.' + CRLF + CRLF +
    '  A calendar is presented with a click on the down arrow.';
end;

procedure TfrmMHA_InstrumentSelect.cbxSortByEnter(Sender: TObject);
begin
  lblInstructions.Caption := CRLF +
    '  The presentation of instruments can be filtered: ' +
    'show all (no filter), ' +
    'only batteries, or ' +
    'only incomplete instruments.';
end;

procedure TfrmMHA_InstrumentSelect.pnlSortMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  cbxSortByEnter(Sender);
end;

procedure TfrmMHA_InstrumentSelect.grpInstructionsMouseMove(
  Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  lblInstructions.Caption := CRLF +
    '  Instructions presented here are dependent on the location of the ' +
    'mouse or cursor.';
end;

procedure TfrmMHA_InstrumentSelect.btnPatientEntryMouseMove(
  Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  lblInstructions.Caption := CRLF +
    '  Patient entry will lock down this computer. Close all ' +
    'programs before using this option.' + CRLF +
    '  When the patient is finished, the computer will ' +
    'return to the log-on screen.';
end;

procedure TfrmMHA_InstrumentSelect.btnStaffEntryMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  lblInstructions.Caption := CRLF +
    '  Staff entry is used to record patient results ' +
    'on psychological test, and mental health forms.';
end;

procedure TfrmMHA_InstrumentSelect.rgrpAdministrationEnter(
  Sender: TObject);
begin
  lblInstructions.Caption := CRLF +
    '  "One question at a time" is recommended for patient entry.' +
    CRLF + CRLF +
    '  "All questions at once" is typically used for staff entry.';
end;

procedure TfrmMHA_InstrumentSelect.rgrpAdministrationMouseMove(
  Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  rgrpAdministrationEnter(Sender);
end;

//------------------------------------------------------------------------------

procedure TfrmMHA_InstrumentSelect.cbxOrderedByNeedData(Sender: TObject;
  const StartFrom: string; Direction, InsertAt: Integer);
begin
  inherited;

  (Sender as TORComboBox).ForDataUse(Staff_OPS.LoadStaffSubSet(StartFrom,
    Direction, DataModule1.RPCBroker1));
end;

procedure TfrmMHA_InstrumentSelect.mnuMetricClick(Sender: TObject);
begin
  VisitURL(MetricURL);
end;


procedure TfrmMHA_InstrumentSelect.UpdateInstrumentResourceFiles;
begin
  lblHeader.Caption := '  Updating files...';
  Screen.cursor := crHourGlass;

  ResourceFile_OPS.CleanAndUpdateResourceFiles;

  if FileExists(LocalFiles.InstrumentFilesPath + '\Names.txt') then
    lvInstrumentHint.LoadFromFile(LocalFiles.InstrumentFilesPath + '\Names.txt');

  lblHeader.Caption := HEADERCAPTION;
  Screen.Cursor := crDefault;
end;

procedure TfrmMHA_InstrumentSelect.cbxOrderedByDropDown(Sender: TObject);
begin
  // OnFormShow does not load cbxOrderedBy items because the method is very
  // slow, and in most cases the lvAdministration.Orderer will indeed be the
  // User. This method will load the items the first time the user clicks
  // on the combobox's down arrow (i.e., when item.count = 0

  if (cbxOrderedBy.Items.Count = 0) then
    begin
      cbxOrderedBy.InitLongList(ThisUser.Name);
      // Patch 129 fix for DUZ's with greater than 9 digits ; changed StrtoInt to StrToInt64 llh
      cbxOrderedBy.SelectByIEN(StrToInt64(ThisUser.DUZ));
    end;

end;

procedure TfrmMHA_InstrumentSelect.cbxOrderedByChange(Sender: TObject);
var
  reply,
    tmpDUZ                    : string;
begin

  tmpDUZ := IntToStr(cbxOrderedBy.ItemIEN);

  if tmpDUZ = '0' then
    exit
  else
    begin
      lvCurrentOrdererDUZ := tmpDUZ;
      lvAdministration.Orderer.Load(tmpDUZ, DataModule1.RPCBroker1);

      reply := Instrument_OPS.LoadListOfAvailableInstruments(lvAdministration.Orderer.AccessKeys);
      if reply <> OK then
        begin
          MsgDlgFrm(' Sorry, there is an error loading the instruments: ' + #13 + reply,
            MHA_Caption, mtError, [mbOK], 0);
          Exit;
        end;
      PrepareListOfIncompletes;

      DisplayEverything;
    end;
end;

procedure TfrmMHA_InstrumentSelect.cbxInterviewerChange(Sender: TObject);
var
  tmpDUZ                      : string;
begin
  tmpDUZ := IntToStr(cbxInterviewer.ItemIEN);

  if (tmpDUZ = '0') or (tmpDUZ = lvAdministration.AdministeredBy) then
    exit
  else
    lvAdministration.AdministeredBy := tmpDUZ;
end;

procedure TfrmMHA_InstrumentSelect.RemoveDeselectedInstrument(AInstrument:
  string);
var
  i                           : integer;
begin

  for i := 0 to lstChosen.Items.Count - 1 do
    if (Trim(lstChosen.Items[i].Caption) = Trim(AInstrument)) then
      begin
        lstChosen.Items[i].Delete;
        Break;
      end;

  UpdateButtons;
end;

function TfrmMHA_InstrumentSelect.IsSecureDesktopInstalled: BOOLEAN;
begin
  Result := False;

  if (FileExists(LocalFiles.MHAPath + 'YS_MHA_VASD.exe') and // SD is present
    //(LMDSysInfo1.Platform = 'Windows NT') and //is this an NT-class OS (Pro)
    (FileExists(GetWindowsSystemFolder + '\dwlGina2.dll'))) then
    {//Special system DLL is installed}
    //if wlIsGinaInstalled = 1 {...and activated} then  *KCM*
      result := True;
end;

procedure TfrmMHA_InstrumentSelect.Startva_SecureDesktop;
var
  CommandString               : array[0..512] of Char;
begin
  frmMHA_SD_Warning := TfrmMHA_SD_Warning.Create(nil);
  try
    frmMHA_SD_Warning.lblNotice.Alignment := taCenter;
    frmMHA_SD_Warning.lblNotice.Caption := CRLF +
      'USE ONLY ALPHA-NUMERIC KEYS ON THE KEYBOARD.' + CRLF + CRLF +

    'Using any other keys may cause the test to abort. ' + CRLF +
      'All keystrokes are monitored for security violations.';

    frmMHA_SD_Warning.btnYes.Visible := False;
    frmMHA_SD_Warning.btnNo.Caption := '&OK';

    frmMHA_SD_Warning.ShowModal;
  finally
    frmMHA_SD_Warning.free;
  end;

  //Invoke va_SecureDesktop app
  StrPCopy(CommandString, LocalFiles.MHAPath + 'YS_MHA_VASD.exe');
  ShellExecute(Handle, 'open', CommandString,
    nil, nil, SW_SHOWMAXIMIZED);

end;

procedure TfrmMHA_InstrumentSelect.mnuExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMHA_InstrumentSelect.mnuOnlineSupportClick(Sender: TObject);
begin
  VisitURL(MHA_ONLINE_SUPPORT_URL);
end;

procedure TfrmMHA_InstrumentSelect.mnuAboutClick(Sender: TObject);
begin
  frmMHA_About := TfrmMHA_About.Create(nil);
  try
    frmMHA_About.ShowModal;
  finally
    frmMHA_About.Free;
  end; //try
end;

procedure TfrmMHA_InstrumentSelect.cbxInterviewerEnter(Sender: TObject);
begin
  // Update the instructions panel.
  lblInstructions.Caption := CRLF +
    '  You may select someone else as the Interviewer, as when a ' +
    'student gives a test. ' + CRLF + CRLF +
    '  Instruments that are available depends on the instrument orderer.';
end;

procedure TfrmMHA_InstrumentSelect.cbxInterviewerDropDown(
  Sender: TObject);
begin
  // OnFormShow does not load cbxInterviewer items because the method is very
   // slow, and in most cases the lvAdministration.AdministeredBy will indeed be the
   // User. This method will load the items the first time the user clicks
   // on the combobox's down arrow (i.e., when item.count = 0

  if (cbxInterviewer.Items.Count = 0) then
    begin
      cbxInterviewer.InitLongList(ThisUser.Name);
      // Patch 129 fix for DUZ's with greater than 9 digits ; changed StrtoInt to StrToInt64 llh
      cbxInterviewer.SelectByIEN(StrToInt64(ThisUser.DUZ));
    end;
end;

procedure TfrmMHA_InstrumentSelect.grpInterviewMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  // Update the instructions panel.
  cbxInterviewerEnter(Sender);
end;

procedure TfrmMHA_InstrumentSelect.cbxLocationChange(Sender: TObject);
begin
  if cbxLocation.ItemIndex <> -1 then
    begin
      lvAdministration.LocationIEN := IntToStr(cbxLocation.ItemIEN);
      lvAdministration.LocationStr := cbxLocation.Text;
    end
  else
    begin
      lvAdministration.LocationIEN := '';
      lvAdministration.LocationStr := '';
    end;
    
// ShowMessage(lvAdministration.LocationIEN +#13+
//      lvAdministration.LocationStr);

end;

procedure TfrmMHA_InstrumentSelect.cbxConsultChange(Sender: TObject);
begin
  if cbxConsult.ItemIndex <> -1 then
    begin
      lvAdministration.ConsultIEN := Piece(cbxConsult.Items[cbxConsult.ItemIndex], U, 1);
    end
  else
    begin
      lvAdministration.ConsultIEN := '';
    end;
end;

procedure TfrmMHA_InstrumentSelect.grpLocationMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  // Update the instructions panel.
  cbxLocationEnter(Sender);
end;

procedure TfrmMHA_InstrumentSelect.grpConsultMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  // Update the instructions panel.
  cbxConsultEnter(Sender);
end;

procedure TfrmMHA_InstrumentSelect.cbxConsultEnter(Sender: TObject);
begin
  // Update the instructions panel.
  lblInstructions.Caption := CRLF +
    '  Select a consult that the report of instrument results will ' +
    'be linked to. This is optional; leave blank otherwise.';
end;

procedure TfrmMHA_InstrumentSelect.cbxLocationEnter(Sender: TObject);
begin
  // Update the instructions panel.
  lblInstructions.Caption := CRLF +
    '  Select location of encounter. Historical ' +
    'visits are not supported.';
end;

procedure TfrmMHA_InstrumentSelect.cbxLocationDropDown(Sender: TObject);
begin
  // OnFormShow does not load cbxLocation items because the method is very
  // slow, and in most cases the location will not change.
  // This method will load the items the first time the user clicks
  // on the combobox's down arrow (i.e., when item.count = 0

  if (cbxLocation.Items.Count = 0) then
    begin
      cbxLocation.InitLongList(cbxLocation.text);
      cbxLocation.SelectByIEN(StrToIntDef(Piece(gvLastLocation, U,
        1), 1));
    end;
end;

procedure TfrmMHA_InstrumentSelect.cbxConsultDropDown(Sender: TObject);
begin
  // OnFormShow does not load cbxConsult items because the method is very
  // slow, and in most cases the consult will not change.
  // This method will load the items the first time the user clicks
  // on the combobox's down arrow (i.e., when items.count = 0)

  if (cbxConsult.Items.Count = 0) then
    begin
      cbxConsult.Items.AddStrings(Consult_OPS.LoadConsultSubSet(Patient.DFN,
        DataModule1.RPCBroker1));
      cbxConsult.DropDownCount := cbxConsult.Items.Count - 1;
    end;
end;

procedure TfrmMHA_InstrumentSelect.cbxLocationNeedData(Sender: TObject;
  const StartFrom: string; Direction, InsertAt: Integer);
begin
  inherited;
  (Sender as TORComboBox).ForDataUse(SubSetOfLocations(StartFrom,
    Direction, DataModule1.RPCBroker1));
end;

procedure TfrmMHA_InstrumentSelect.rbOneAtATimeMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  rbOneAtATimeEnter(Sender);
end;

procedure TfrmMHA_InstrumentSelect.rbOneAtATimeEnter(Sender: TObject);
begin
  lblInstructions.Caption := CRLF +
    '  "One question at a time" is recommended for patient entry.'
    + CRLF + CRLF +
    '  "All questions at once" is typically used for staff entry.';
end;

//------------------------------------------------------------------------------
//       Virtual Tree Stuff
//------------------------------------------------------------------------------

procedure TfrmMHA_InstrumentSelect.treSelectGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: string);
var
  Data                        : PSelectData;
begin
  Data := Sender.GetNodeData(Node);
  CellText := Data.Caption;
end;


function TfrmMHA_InstrumentSelect.treSelectGetChildCount(NodeIn: string): integer;
var
  i                           : integer;
begin
  Result := 0;

  for i := 0 to lvtreSelectItems.Count - 1 do
    begin
      if NodeIn = Piece(lvtreSelectItems[i], '=', 1) then
        begin
          Result := NumberOfPieces(lvtreSelectItems[i], U) - 1;
          break;
        end;
    end;
end;


procedure TfrmMHA_InstrumentSelect.treSelectInitChildren(Sender: TBaseVirtualTree;
  Node: PVirtualNode; var ChildCount: Cardinal);
var
  Data                        : PSelectData;
begin
  lvChildren := 0;
  Data := Sender.GetNodeData(Node);
  ChildCount := treSelectGetChildCount(Data^.Caption);
end;

function TfrmMHA_InstrumentSelect.treSelectGetItems(PNode: string; ChildNumber: integer): string;
var
  i, j                        : integer;
  TempStr                     : string;
begin

  Result := '';
  for i := 0 to lvtreSelectItems.Count - 1 do
    begin
      if PNode = Piece(lvtreSelectItems[i], '=', 1) then
        begin
          TempStr := Piece(lvtreSelectItems[i], U, ChildNumber + 1);
          // First child has root in its name.
          j := Pos('=', TempStr);
          if j > 0 then
            Result := Copy(TempStr, j + 1, Length(TempStr))
          else
            Result := TempStr;
        end;
    end;
end;

function TfrmMHA_InstrumentSelect.treSelectGetHasChildren(NodeName: string): Boolean;
var
  i                           : integer;
begin
  Result := False;
  for i := 0 to lvtreSelectItems.Count - 1 do
    if NodeName = Piece(lvtreSelectItems[i], '=', 1) then
      begin
        Result := True;
        break;
      end;
end;

procedure TfrmMHA_InstrumentSelect.treSelectInitNode(Sender: TBaseVirtualTree;
  ParentNode, Node: PVirtualNode; var InitialStates: TVirtualNodeInitStates);
var
  DataP,
    Data                      : PSelectData;
begin
  Data := Sender.GetNodeData(Node);

  if ParentNode = nil then // Parent nodes
    begin
      Data^.Caption := treSelectGetItems('Root', lvRootNode);
      if treSelectGetHasChildren(Data^.Caption) then
        begin
          Data^.Style := 'B'; // Battery
          InitialStates := [ivsHasChildren];
        end
      else
        begin
          InitialStates := [];
          if Pos('(', Data^.Caption) > 0 then
            Data^.Style := 'I' //Incomplete
          else
            Data^.Style := 'R'; //Regular
        end;
      Inc(lvRootNode);
    end
  else
    begin
      DataP := Sender.GetNodeData(ParentNode);
      Data^.Caption := treSelectGetItems(DataP^.Caption, lvChildren);

      if treSelectGetHasChildren(Data^.Caption) then
        InitialStates := [ivsHasChildren]
      else
        begin
          InitialStates := [];
          Data^.Style := 'R'; //Regular
        end;
      Inc(lvChildren);
    end;

  Node.NodeHeight := lvNodeHeight;
  Node.CheckType := ctCheckBox;
  Sender.CheckState[Node] := csUnCheckedNormal;
end;

procedure TfrmMHA_InstrumentSelect.treSelectUnCheckThisNode(ThisNode: string);
// This is used to uncheck a given instrument when it is dropped from the
// list of selected instruments
var
  Node                        : PVirtualNode;
  Data                        : PSelectData;
  i                           : Integer;
begin
  Node := treSelect.GetFirst;
  for i := 1 to treSelect.RootNodeCount - 1 do
    begin
      Node := treSelect.GetNextSibling(Node);
      Data := treSelect.GetNodeData(Node);
      if Data^.Caption = ThisNode then
        treSelect.CheckState[Node] := csUnCheckedNormal;
    end;
  treSelect.Refresh;
end;


procedure TfrmMHA_InstrumentSelect.treSelectUnCheck;
// This is used to uncheck all nodes
var
  Node                        : PVirtualNode;
  i                           : Integer;
begin

  Node := treSelect.GetFirst;
  for i := 1 to treSelect.RootNodeCount - 1 do
    begin
      Node := treSelect.GetNextSibling(Node);
      treSelect.CheckState[Node] := csUnCheckedNormal;
    end;
  treSelect.Refresh;

end;

procedure TfrmMHA_InstrumentSelect.treSelectChecked(
  Sender: TBaseVirtualTree; Node: PVirtualNode);
var
  i, j                        : Integer;
  Data                        : PSelectData;
begin

  if Node.CheckState = csCheckedNormal then
    begin

  // Before placing instrument in the Chosen List, make sure the veteran is
  // alive on the "date of administration"
      if Patient.IsDead then
        begin
          if StrToDate(Patient.DOD) < dtpkAdministration.DateTime then
            begin
              MsgDlgFrm(' Sorry, this veteran died on ' + Patient.DOD + '.',
                MHA_Caption, mtInformation, [mbOK], 0);
              treSelectUnCheck;
              exit;
            end;
        end;

      // Place the checked instrument(s) in the Chosen list
      Data := Sender.GetNodeData(Node);

      //Result of WIN7SCROLLBUG - add message to alert user font size
      //                          critical on long instruments llh patch 105
      if (Data.Caption = 'AUIR') or (Data.Caption = 'MMPI2') or
         (Data.Caption = 'NEOPI') or (Data.Caption = 'PAI') then
         MessageDlg('**PLEASE NOTE: This instrument has been identified as a long' + #13 +
                    'instrument. Using or changing to a font size larger than the' + #13 +
                    'default size of 10, MAY cause display issues of the questions.** ',
                     mtInformation, [mbOK], 0);
      // end WIN7SCROLLBUG

      if Data.Style = 'B' then // Battery checked, move the instruments over
        begin
          treSelect.Expanded[Node] := True;
          j := Node.ChildCount - 2;
          Node := treSelect.GetFirstChild(Node);
          Data := Sender.GetNodeData(Node);

          lstChosen.Items.Add.Caption := Trim(Data.Caption);
          for i := 0 to j do
            begin
              Node := treSelect.GetNextSibling(Node);
              Data := Sender.GetNodeData(Node);
              lstChosen.Items.Add.Caption := Trim(Data.Caption);
            end
        end
      else
        begin
          // Check YS_MHA_AUX.dll is up to date for this nstrument.
          if (DataBaseMode <> dbVistA) and (not InstrumentAllowed(Data.Caption)) then
            Exit;

          lstChosen.Items.Add.Caption := Trim(Data.Caption);

          // Incomplete administrations
          if Pos('(', Data.Caption) > 0 then
            begin
              if DataBaseMode = dbVista then
                MsgDlgFrm('Reminder ' + CRLF + CRLF +
                  // llh post patch 129; changed proceding to proceeding
                  'Before proceeding, ensure the information is correct for: ' +
                  CRLF + CRLF +
                  '    Instrument Ordered By ' + CRLF +
                  '    Interviewer ' + CRLF +
                  '    Date of Administration ' + CRLF +
                  '    Visit Location' + CRLF +
                  '    Consult (optional).' + CRLF + CRLF +
                  'These usually have default values and may need adjusting.',
                  MHA_Caption, mtInformation, [mbOK], 0)
              else
          // Off-line, incomplete instrument
                MsgDlgFrm('Reminder ' + CRLF + CRLF +
                  // llh post patch 129; changed proceding to proceeding
                  'Before proceeding, ensure the information is correct for ' +
                  '"Date of Administration." The default date may need adjusting.',
                  MHA_Caption, mtInformation, [mbOK], 0)
            end;
        end;

      // Remove redundant items
      lstChosenRedundant;
    end
  else // Unchecked
    begin
      if Node.ChildCount > 0 then
        begin
          j := Node.ChildCount;

          Node := treSelect.GetFirstChild(Node);
          Data := Sender.GetNodeData(Node);
          RemoveDeselectedInstrument(Data.Caption);
          if j > 1 then
            begin
              for i := 2 to j do
                begin
                  Node := treSelect.GetNextSibling(Node);
                  Data := Sender.GetNodeData(Node);
                  RemoveDeselectedInstrument(Data.Caption);
                end;
            end;
        end

      else
        begin
          Data := Sender.GetNodeData(Node);
          RemoveDeselectedInstrument(Data.caption);
        end;
      Exit;
    end;

end;


procedure TfrmMHA_InstrumentSelect.treSelectEnter(Sender: TObject);
begin
  // Update the instructions panel.
  lblInstructions.Caption :=
    ' Select the instrument by checking its box with the mouse, or ' +
    'use the arrow keys and space-bar to select.' + CRLF +
    '  Underlined instruments are incomplete.' + CRLF +
    '  Bold indicates a battery which contains many instruments.';

  if DataBaseMode = dbVistA then
    lblInstructions.Caption := lblInstructions.Caption +
      CRLF + '  Right click on an instrument for more information.';
end;

procedure TfrmMHA_InstrumentSelect.treSelectMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  // Update the instructions panel.
  treSelectEnter(Sender);
end;

procedure TfrmMHA_InstrumentSelect.treSelectPaintText(
  Sender: TBaseVirtualTree; const TargetCanvas: TCanvas;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType);
var
  Data                        : PSelectData;
begin

  if gvUseScreenReader then
    Exit;

  Data := Sender.GetNodeData(Node);
  case Data.Style of
    'B': // Battery are bold
      TargetCanvas.Font.Style := TargetCanvas.Font.Style + [fsBold];
    'I': // Incomplete are underlined
      begin
        TargetCanvas.Font.Style := TargetCanvas.Font.Style + [fsUnderline];
        TargetCanvas.Font.Color := clMaroon;
      end;
  end; //case

end;

procedure TfrmMHA_InstrumentSelect.treSelectGetImageIndex(
  Sender: TBaseVirtualTree; Node: PVirtualNode; Kind: TVTImageKind;
  Column: TColumnIndex; var Ghosted: Boolean; var ImageIndex: Integer);
var
  Data                        : PSelectData;

begin

  if gvUseScreenReader then
    Exit;

  Data := Sender.GetNodeData(Node);
  case Data.Style of
    'R': // Regular
      ImageIndex := IconInstrument;
    'B': // Battery
      ImageIndex := IconBattery;
    'I': // Incomplete
      ImageIndex := IconIncomplete;
  end; //case
end;

procedure TfrmMHA_InstrumentSelect.treSelectClick(Sender: TObject);
begin
  if (DataBaseMode = dbVistA) then
    begin
      mnuInstrumentDescription.Enabled := True;
      mnuDescription.Enabled := true;
    end;
end;

procedure TfrmMHA_InstrumentSelect.imgBackupClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMHA_InstrumentSelect.treSelectDblClick(Sender: TObject);
begin
//treSelectChecked(treSelect, treSelect.GetFirstSelected);
end;

procedure TfrmMHA_InstrumentSelect.mnuPrintBlankClick(Sender: TObject);
begin

  gvNameOfInstrument := '';
  try
    frmPrint_Instrument := TfrmPrint_Instrument.Create(nil);
  finally
    frmPrint_Instrument.Free;
  end; //try

end;

procedure TfrmMHA_InstrumentSelect.FormResize(Sender: TObject);
begin
  if lvInitialize then
    Exit;

  // Reset these, used in placement of dialogs
  gvLeft := Left;
  gvTop := Top;
  gvHeight := Height;
  gvWidth := Width;
end;

procedure TfrmMHA_InstrumentSelect.rbAllAtOnceClick(Sender: TObject);
begin
  gvShowAllOrOneItem := rbAllAtOnce.Checked;
end;

procedure TfrmMHA_InstrumentSelect.rbOneAtATimeClick(Sender: TObject);
begin
  gvShowAllOrOneItem := rbAllAtOnce.Checked;
end;

procedure TfrmMHA_InstrumentSelect.treSelectGetHint(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex;
  var LineBreakStyle: TVTTooltipLineBreakStyle; var HintText: string);
var
  Data                        : PSelectData;
  TempStr                     : string;
begin
  if gvUseScreenReader then
    Exit;

  if lvInstrumentHint.count = 0 then
    exit;

  Data := Sender.GetNodeData(Node);
  TempStr := Data.Caption;
  HintText := lvInstrumentHint.Values[TempStr];
end;

procedure TfrmMHA_InstrumentSelect.lbSelectKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
// 508 instrument selection
begin
  // patch 129 llh -- did not make any changes here.  hint for 508 compliance said space bar, change it
  //                  in configureForm procedure to indicate the return key.
  if Key = vk_Return then
    begin
      if (cbxLocation.ItemIndex = -1) and (DataBaseMode = dbVista) then
        begin
          MessageDlg('Please select a "Visit Location" before proceeding.', mtError,
            [mbOK], 0);
          Exit;
        end;

      lstChosen.Items.Clear;
      lstChosen.Items.Add.Caption := lbSelect.Items.Strings[lbSelect.ItemIndex];
      Proctor.DataEntryMode := emStaff;

      DisplaySelectedInstruments;
    end;
end;


procedure TfrmMHA_InstrumentSelect.btnScrRdrExitClick(Sender: TObject);
begin
  close ;
end;

end.

