unit fMHA_SD_Warning;

interface

uses Windows,
  SysUtils,
  Classes,
  Graphics,
  Forms,
  Controls,
  StdCtrls,
  Buttons,
  ExtCtrls,
  JvExControls,
  JvComponent,
  JvXPCore,
  JvXPButtons;

type
  TfrmMHA_SD_Warning = class(TForm)
    lblWarning: TLabel;
    pnlBottom: TPanel;
    lblNotice: TLabel;
    pnlSpacer1: TPanel;
    pnlSpacer0: TPanel;
    btnYes: TJvXPButton;
    btnNo: TJvXPButton;
    procedure btnYesClick(Sender: TObject);
    procedure btnNoClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMHA_SD_Warning           : TfrmMHA_SD_Warning;

implementation

uses
  uMHA_Registry,
  uIA_Const,
  uIA_GUIControl;

{$R *.DFM}

procedure TfrmMHA_SD_Warning.FormCreate(Sender: TObject);
begin
  // The text for lblNotice.caption is set in fMHA3_InstrumentSelect and
  // fMHA3_Admin.
    // Keep Position out of ConfigureForm when ConfigureForm can be called
  // more than once with the form.
  Position := poDesigned;

  with GUI_Control do
    begin
      Font.Assign(gvFont);
      Caption := 'Restrictive use warning';
      lblNotice.Font.Assign(gvFont);
      Height := GetHeight(lblWarning.Height + (12 * ButtonHeight));
      Width := GetWidth(5 * ButtonWidthNormal);
      Left := GetLeft(Width);
      Top := GetTop(Height);
      if CheckWidth(Width) or CheckHeight(Height) then
        WindowState := wsMaximized;
      Refresh; // resets alClient dimensions

      pnlBottom.Height := 3 * ButtonHeight div 2;
      btnYes.Font.Assign(gvFont);
      btnYes.Height := ButtonHeight;
      btnYes.Width := ButtonWidthNormal;
      btnYes.Top := pnlBottom.Height div 4;
      btnYes.Left := LeftForSecondButton(pnlBottom.Width);

      btnNo.Font.Assign(gvFont);
      btnNo.Height := ButtonHeight;
      btnNo.Width := ButtonWidthNormal;
      btnNo.Top := btnYes.Top;
      btnNo.Left := LeftForFirstButton(pnlBottom.Width);
    end;

  if gvUseScreenReader then
    begin
      //btnYEs.caption := btnYes.Caption + ' button';
      //btnNo.caption := btnNo.Caption + ' button';
      Caption := caption + ' ' + lblNotice.Caption;
    end;

  Screen.Cursor := crDefault;
  ActiveControl := btnYes;
end;

procedure TfrmMHA_SD_Warning.btnYesClick(Sender: TObject);
begin
  ModalResult := mrYes;
end;

procedure TfrmMHA_SD_Warning.btnNoClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TfrmMHA_SD_Warning.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Shift = [ssALT]) and (Key = vk_F4) then
    begin
      ModalResult := mrCancel;
      Close;
      Key := 0;
    end;

  if Key = vk_Escape then
    begin
      ModalResult := mrCancel;
      Close;
      Key := 0;
    end;
end;

end.

