{**
Initial splash screen
}
{===============================================================
 UNIT NAME: fMHA3_Splash, PROJECT: MHA3
 PACKAGE: YS - Mental Health
 WARNING: None
 DATE CREATED: 7/7/2004
 SITE NAME: Salt Lake City, MHSHG Mental Health Informatics Section

 HISTORY:

 Required third-party Delphi components and libraries:

****************************************************************

 NOTES:

}


unit fMHA_Splash;
(*
   See page 333 of Delphi Developer's Guide by
     X. Pacheco & S. Teixeira for details of the Splash unit. -}

   Do not add this unit to the project. It should be listed in the "Uses" of
     the main form, but no where else.
*)

interface

uses WinTypes,
  WinProcs,
  Classes,
  Graphics,
  Forms,
  SysUtils,
  Controls,
  StdCtrls,
  ExtCtrls,
  jpeg;


type
  TSplashScreen = class(TForm)
    Image1: TImage;
    lblVersion: TLabel;
    imgLogo: TImage;
    lblLoading: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SplashScreen: TSplashScreen;

implementation

{$R *.DFM}

// p108v71 llh XE3 migration, for issue with splashscreen being released
//              in frmMain
procedure TSplashScreen.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  destroy ;
end;

procedure TSplashScreen.FormCreate(Sender: TObject);
var
  ASize, AHandle: DWORD;
  TempStr, Buf: string;
  FileInfoPtr: Pointer;
  i:integer;
begin

  if ParamCount < 6 then
    begin
      lblLoading.Visible := false;
      lblVersion.caption := '0.0.0.0'; // Default
      ASize := GetFileVersionInfoSize(PChar(Application.ExeName), AHandle);
      if ASize > 0 then
        begin
          SetLength(Buf, ASize);
          GetFileVersionInfo(PChar(Application.ExeName), AHandle, ASize, Pointer(Buf));
          VerQueryValue(Pointer(Buf), '\', FileInfoPtr, ASize);
          with TVSFixedFileInfo(FileInfoPtr^) do
            lblVersion.caption :=
              IntToStr(HIWORD(dwFileVersionMS)) + '.' +
              IntToStr(LOWORD(dwFileVersionMS)) + '.' +
              IntToStr(HIWORD(dwFileVersionLS)) + '.' +
              IntToStr(LOWORD(dwFileVersionLS)) + '  ';
        end;
    end
  else
    begin
      imgLogo.Visible := false;
      lblVersion.Visible := false;
      for i := 6 to ParamCount do
        TempStr := TempStr + ' ' + ParamStr(i);
      TempStr := Trim(UpperCase(TempStr));
      lblLoading.Caption := 'Loading ' + TempStr + '...';
      lblLoading.Visible := true;
    end;
end;


procedure TSplashScreen.FormShow(Sender: TObject);
begin
  // Move the splash screen off center so that any error or Windows process
  // dialogs can be displayed.
  Top := (Screen.Height - Height) div 3;
  Left := (Screen.Width - Width) div 3;
end;


begin
  Screen.Cursor := crHourGlass;
  SplashScreen := TSplashScreen.Create(Application);
  SplashScreen.Show;
  SplashScreen.Update;
end.

