unit fMHA_SplashScreen;

// XE3 migration llh, this is a new SplashScreen


interface

uses
  Winapi.Windows,
  Winapi.Messages,
  System.SysUtils,
  //System.Variants,
  System.Classes,
  Vcl.Graphics,
  Vcl.Controls,
  Vcl.Forms,
  Vcl.Dialogs,
  Vcl.ExtCtrls,
  Vcl.StdCtrls;


type
  TfrmMHA_SplashScreen = class(TForm)
    imgLogo: TImage;
    Image1: TImage;
    lblLoading: TLabel;
    lblVersion: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  frmMHA_SplashScreen: TfrmMHA_SplashScreen;

implementation

{$R *.dfm}

procedure TfrmMHA_SplashScreen.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  action := cafree ;
end;

procedure TfrmMHA_SplashScreen.FormCreate(Sender: TObject);
var
  ASize, AHandle: DWORD;
  TempStr, Buf: string;
  FileInfoPtr: Pointer;
  i:integer;
begin

  if ParamCount < 6 then
    begin
      lblLoading.Visible := false;
      lblVersion.caption := '0.0.0.0'; // Default
      ASize := GetFileVersionInfoSize(PChar(Application.ExeName), AHandle);
      if ASize > 0 then
        begin
          SetLength(Buf, ASize);
          GetFileVersionInfo(PChar(Application.ExeName), AHandle, ASize, Pointer(Buf));
          VerQueryValue(Pointer(Buf), '\', FileInfoPtr, ASize);
          with TVSFixedFileInfo(FileInfoPtr^) do
            lblVersion.caption :=
              IntToStr(HIWORD(dwFileVersionMS)) + '.' +
              IntToStr(LOWORD(dwFileVersionMS)) + '.' +
              IntToStr(HIWORD(dwFileVersionLS)) + '.' +
              IntToStr(LOWORD(dwFileVersionLS)) + '  ';
        end;
    end
  else
    begin
      imgLogo.Visible := false;
      lblVersion.Visible := false;
      for i := 6 to ParamCount do
        TempStr := TempStr + ' ' + ParamStr(i);
      TempStr := Trim(UpperCase(TempStr));
      lblLoading.Caption := 'Loading ' + TempStr + '...';
      lblLoading.Visible := true;
    end;
end;

procedure TfrmMHA_SplashScreen.FormShow(Sender: TObject);
begin
  // Move the splash screen off center so that any error or Windows process
  // dialogs can be displayed.
  Top := (Screen.Height - Height) div 3;
  Left := (Screen.Width - Width) div 3;
end;

procedure TfrmMHA_SplashScreen.FormDestroy(Sender: TObject);
begin
  frmMHA_SplashScreen := nil;
end;

//XE6 -- added to see if this will remove the access violation error
begin
  Screen.Cursor := crHourGlass;
  frmMHA_SplashScreen := TfrmMHA_SplashScreen.Create(Application);
  frmMHA_SplashScreen.Show;
  frmMHA_SplashScreen.Update;
end.


end.
