unit uMHA_ASI_Save;

interface

uses
  Windows,
  Messages,
  SysUtils,
  System.Contnrs,
  Classes,
  comctrls,
  Graphics,
  Controls,
  Forms,
  Fmcmpnts,
  Diaccess,
  StdCtrls,
  ExtCtrls,
  RzPanel,
  RzRadGrp,
  Mask,
  RzEdit,
  RzCmboBx,
  Fmcntrls,
  uMHA_ASI;

procedure ASI_SaveOnTheRun;

function ASI_SaveData(aRecordIENS,
  aPatientDFN,
  aInterviewerDUZ,
  aOrderedByDUZ,
  ADate,
  aProgramIEN: string;
  aInterviewType: TInterviewType): string;

implementation

uses
  fMHA_ASI_Entry,
  uMHA_ASI_OPS,
  fIA_dialogs, Dialogs,
  uMHA_LocalFiles,

  uIA_Patient,
  uIA_ThisUser,
  uIA_Utils,
  uIA_Const,
  uMHA_Const,
  uMHA_DM;

procedure ASI_SaveOnTheRun;
// This is the text file augmented with each user's response and
// saved immediately. This a protection against crashes. The text file is
// deleted upon a normal closing of the program.
var
  i                           : integer;
//  TempG11,
  TempG3,
    TempStr                   : string;
begin

  with frmMHA_ASI_Entry do
    begin
      ASI_OPS.ChoicesMade.Clear;
      TempG3 := '';
//    TempG11 := '';
  //Screen.Cursor := crhourglass;
  // The first line of the text file has the type of ASI (Full, Lite, etc),
  // the RecordIENS, the patient identifier, the staff identifier and
  // program identifier.
      if cbxG3.ItemIndex <> -1 then
        TempG3 := inttostr(cbxG3.ItemIndex + 1)
      else
        TempG3 := '1';

//    if cbxG11.ItemIndex <> -1 then
//      TempG11 := Piece(cbxG11.Items[cbxG11.ItemIndex], '^', 1)
//    else
//      TempG11 := '1';

      TempStr := TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewTypeStr + U
        + TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).IENS + U
        + Patient.DFN + U
        + TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewerDUZ + U
        + TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).OrderedByDUZ + U
        + TempG3;

      ASI_OPS.ChoicesMade.Add(TempStr);
//*  TempStr := ASI_Vista.RecordIEN + '^' + Patient.DFN + '^' +
//*    TempG11 + '^' + TempG3;
//    OrderedByIEN := TempG11; // IENS numbers
      ProgramIEN := TempG3;
//    if rgrpG8.ItemIndex = -1 then
//      ASI_OPS.ChoicesMade.Add('Full^' + TempStr);
//    if rgrpG8.ItemIndex = 0 then
//      ASI_OPS.ChoicesMade.Add('Full^' + TempStr);
//    if rgrpG8.ItemIndex = 1 then
//      ASI_OPS.ChoicesMade.Add('Lite^' + TempStr);
//    if rgrpG8.ItemIndex = 2 then
//      ASI_OPS.ChoicesMade.Add('Followup^' + TempStr);
      for i := 0 to ComponentCount - 1 do
        begin
    // Program Note: the order of these components must match that on the
    // recovery side.
          if Components[i] is TEdit then
            ASI_OPS.ChoicesMade.Add(TEdit(Components[i]).Text);
          if Components[i] is TRzEdit then
            ASI_OPS.ChoicesMade.Add(TRzEdit(Components[i]).Text);
          if Components[i] is TDateTimePicker then
            ASI_OPS.ChoicesMade.Add(DateToStr(TDateTimePicker(Components[i]).Date));
          if Components[i] is TRzRadioGroup then
            ASI_OPS.ChoicesMade.Add(IntToStr(TRzRadioGroup(Components[i]).ItemIndex));
          if Components[i] is TRzComboBox then
            ASI_OPS.ChoicesMade.Add(TRzComboBox(Components[i]).Text);
      // the TORComboBox is not saved since the staff ID and Program ID are
      // IENS, not names.

        end;
  //Screen.Cursor := crDefault;
      try
        ASI_OPS.ChoicesMade.SaveToFile(LocalFiles.ASI_RecoveryFile);

      except
        on E: Exception do
          begin
            MessageBeep(MB_ICONASTERISK);
            MsgDlgFrm('The file that saves the data continuously has an error: ' + e.message,
              'Addiction Severity Index',
              mtError, [mbOk], 0);
          end;
      end;
    end;
end;

function ASI_SaveData(aRecordIENS,
  aPatientDFN,
  aInterviewerDUZ,
  aOrderedByDUZ,
  ADate,
  aProgramIEN: string;
  aInterviewType: TInterviewType): string;
var
  TempIENS : string;

  function OkToSaveItem(ItemName: string): Boolean;
  // With partial ASI, save only the items where the user provides input.
  // Do not save the items where default values are provided without the user
  // confirming the input. If the item has ever been active, it will be placed
  // ResponseList.
  // In crash recovery situations, save the data "as is"
  begin
    with frmMHA_ASI_Entry do
      begin
        result := true;
//DC    if frmMain.ASI_Crash then exit;
        if FileExists(LocalFiles.ASI_RecoveryFile) then
          exit;
        if ((rgrpG12.ItemIndex = 3) and (not FUserTerminates)) then
          exit; // Vet finished ASI
    // Did the user ever enter this item?
        if Pos(UpperCase(ItemName), ResponseList) > 0 then
          exit;
        Result := false;
      end;
  end;

  procedure SaveDate(MCode: string; Item: TDateTimePicker);
  begin
    with frmMHA_ASI_Entry do
      begin

        // Remove the time from DateTime
        ASI_OPS.ChoicesMade.Add(MCode + FloatToStrF(DateTimeToFMDateTime(Item.Date),
          ffFixed, 14, 0) + '^');
      end;
  end;

  procedure SaveEdit(Mcode: string; Item: TEdit);
  // These are spin edit boxes
  var
    TempStr                   : string;
  begin
    with frmMHA_ASI_Entry do
      begin
        if OkToSaveItem(Item.Name) then
          begin
            TempStr := Item.text;
      // Saving a blank on the M-side will cause a crash,
      // "X" indicates "Not answered."
            if TempStr = '' then
              TempStr := 'X';
      // Strip a leading 0 from the number: Vista will not accept it
            while ((Length(TempStr) > 1) and (TempStr[1] = '0')) do
              Delete(TempStr, 1, 1); // remove leading zero
            ASI_OPS.ChoicesMade.Add(MCode + TempStr + '^');
          end;
      end;
  end;

  procedure SaveRzEdit(Mcode: string; Item: TRzEdit);
  // These are free text boxes
  begin
    with frmMHA_ASI_Entry do
      begin
        if OkToSaveItem(Item.Name) then
          begin
         // Saving a blank on the M-side will cause a crash.
            if Item.text = '' then
              Item.text := 'Not answered.';
            ASI_OPS.ChoicesMade.Add(MCode + Item.text + '^');
          end;
      end;
  end;

  procedure SaveRadioGroup(MCode: string; Item: TRzRadioGroup; Start, X, N: integer);
  // Standard radio group
  var
    Save                      : string;
  begin
    with frmMHA_ASI_Entry do
      begin
        save := '';
    // There have been checks on reguired items already. A blank item now
    // will get an "X"
        if Item.ItemIndex >= Start then
          begin
            save := IntToStr(Item.ItemIndex + Start);
            if Item.ItemIndex = X then
              save := 'X';
            if Item.ItemIndex = N then
              save := 'N';
          end;
        if Item.ItemIndex = -1 then
          save := 'X';
        if Start = 1 then
          if Item.ItemIndex = 0 then
            save := IntToStr(Start);
        if Start = 0 then
          if Item.ItemIndex = 0 then
            save := IntToStr(Start);
        if OkToSaveItem(Item.Name) then
          ASI_OPS.ChoicesMade.Add(MCode + save + '^');
      end;
  end; // Radio Group Answer function

  procedure SaveComboBox(MCode: string; Item: TRzComboBox; Start, X, N: integer);
  var
    save                      : string;
  begin
    with frmMHA_ASI_Entry do
      begin
        save := '';
    // There have been checks on reguired items already. A blank item now
    // will get an "X"
        if Item.ItemIndex = -1 then
          save := 'X';
        if Start = 1 then
          if Item.ItemIndex = 0 then
            save := IntToStr(Start);
        if Item.ItemIndex >= Start then
          begin
            save := IntToStr(Item.ItemIndex + Start);
            if Item.ItemIndex = X then
              save := 'X';
            if Item.ItemIndex = N then
              save := 'N';
          end;
        if OkToSaveItem(Item.Name) then
          ASI_OPS.ChoicesMade.Add(MCode + save + '^');
      end;
  end; // Combo Box Answer function

  procedure SaveRadioGroupII(MCode: string; Item: TRzRadioGroup);
  // Used for L23 (14.26) and L25 (14.28)
  var
    Save                      : string;
  begin
    with frmMHA_ASI_Entry do
      begin
        save := '';
        case Item.ItemIndex of
          0: save := '3';
          1: save := '4';
          2: save := '5';
          3: save := '6';
          4: save := '7';
          5: save := '8';
          6: save := '9';
          7: save := '10';
          8: save := '11';
          9: save := '12';
          10: save := '13';
          11: save := '14';
          12: save := '15';
          13: save := '16';
          14: save := '18';
          15: save := '19';
          16: save := '20';
          17: save := 'X';
          18: save := 'N';
        end;
        if OkToSaveItem(Item.Name) then
          ASI_OPS.ChoicesMade.Add(MCode + save + '^');
      end;
  end; // Legal Radio Group

  procedure SaveRadioGroupIII(MCode: string; Item: TRzRadioGroup);
  // Used for D14 (10.45)
  var
    Save                      : string;
  begin
    with frmMHA_ASI_Entry do
      begin
        save := '';
        case Item.ItemIndex of
          0: save := '0';
          1: save := '1';
          2: save := '2';
          3: save := '3';
          4: save := '4';
          5: save := '5';
          6: save := '6';
          7: save := '7';
          8: save := '8';
          9: save := '9';
          10: save := '10';
          11: save := '11';
          12: save := '12';
          13: save := '15';
          14: save := '16';
          15: save := 'X';
          16: save := 'N';
        end;
        if OkToSaveItem(Item.Name) then
          ASI_OPS.ChoicesMade.Add(MCode + save + '^');
      end;
  end; // Legal Radio Group

  procedure SaveCommentField(Memo: TFMMemo; Field: string);
  begin
    if Memo.Text = '' then
      exit;

    with frmMHA_ASI_Entry, Memo do
      begin
      // The carriage returns in the memo are saved on the M-side.
      // Make the comments fields the same as Vista-size fields.
      // Do not turn off WordWrap--comment will not be saved at all.
        Align := alNone;
        Font.Name := 'Courier New';
        Font.Size := 9;
        Width := 567;
      // re-wrap
        Refresh;

        FMFile := '604';
        FMField := Field;
        //IENS := TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).IENS;
        IENS := TempIENS;

        DataModule1.RPCBroker1.CreateContext('YS BROKER1');
        
      // Set the FMFiler property to the TFMFiler component to use to file changes.
        FMFiler := DataModule1.FMFiler1;
      //Add the particular memo control to the list of controls to be updated.
        FMFiler.AddChgdControl(memo);
      // regular screen is returned when rebuilt, don't do it here.
      end;
  end;


// main part of the SaveData procedure
begin
  Result := OK;

  with frmMHA_ASI_Entry do
    begin

      if not FASITimedOut then
        begin
          Screen.Cursor := crHourglass;
          lblHint.Caption := 'Saving data . . . .';
        end;

  // Run this once, just in case the user makes no reponses,
  // as this sets the IENS for user and program.
//      if aProgramIEN = '' then
//        ASI_SaveOnTheRun;

      ASI_OPS.ChoicesMade.Clear;

  // General---------------------------------------------------------
      ASI_OPS.ChoicesMade.Add('NAME^.02^' + aPatientDFN + '^');
      ASI_OPS.ChoicesMade.Add('INTRCODE^.81^' + aInterviewerDUZ + '^');
      ASI_OPS.ChoicesMade.Add('ORDEREDBY^.09^' + aOrderedByDUZ + '^');
      ASI_OPS.ChoicesMade.Add('PROGRAM^2^' + aProgramIEN + '^');
      SaveDate('ADMITED^1^', dtpG4);
      SaveDate('INTDATE^.05^', dtpG5);
      SaveRadioGroup('CLASS^.04^', rgrpG8, 1, -1, -1);
      SaveRadioGroup('CONTACT^.07^', rgrpG9, 1, -1, -1);
      SaveRadioGroup('SPECIAL^.11^', rgrpG12, 1, -1, 3);

      if (rgrpG8.ItemIndex <> 2 {Followup}) then
        begin
          SaveEdit('ADDYEARS^1.201^', edtG14y);
          SaveEdit('ADDMONTS^1.202^', edtG14m);
          if (rgrpG8.ItemIndex = 0 {Full}) then
            SaveRadioGroup('OWNHOME^1.203^', rgrpG15, 0, 2, -1);
          if rgrpG17.ItemIndex <> -1 then
            SaveRadioGroup('RACE^.16^', rgrpG17, 1, -1, -1);
          if rgrpG18.ItemIndex <> -1 then
            SaveRadioGroup('RELIGION^.17^', rgrpG18, 1, -1, -1);
        end;

      SaveRadioGroup('CONENV^2.01^', rgrpG19, 1, 6, 7);
      if edtG19e.Enabled then
        SaveRzEdit('OTHER^2.02^', edtG19e);
      if edtG20.Enabled then // see page 92, pink manual
        begin
          SaveEdit('CONENTIM^2.03^', edtG20);
        end
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('CONENTIM^2.03^N^');

  // Medical --------------------------------------------------------
      SaveEdit('HOSPLIFE^8.01^', edtM1);
      if (rgrpG8.ItemIndex = 0 {Full}) then
        begin
          if edtM2y.Enabled then // see page 92, pink manual
            begin
              SaveEdit('HOSPYEAR^8.02^', edtM2y);
            end
          else
            if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
              ASI_OPS.ChoicesMade.Add('HOSPYEAR^8.02^N^');
          if edtM2m.Enabled then // see page 92, pink manual
            begin
              SaveEdit('HOSPMONT^8.025^', edtM2m);
            end
          else
            if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
              ASI_OPS.ChoicesMade.Add('HOSPMONT^8.025^N^');
        end;
      if (rgrpG8.ItemIndex <> 2 {Followup}) then
        begin
          SaveRadioGroup('CHRONMED^8.03^', rgrpM3, 0, 2, -1);
          if edtM3e.Enabled then
            SaveRzEdit('CHRONMEDSPEC^8.04^', edtM3e);
        end;

      SaveRadioGroup('MEDICATS^8.05^', rgrpM4, 0, 2, -1);
      SaveRadioGroup('PHYSDIS^8.06^', rgrpM5, 0, 2, -1);
      if edtM5e.Enabled then
        SaveRzEdit('PHYSDISSPEC^8.07^', edtM5e);
      SaveEdit('DAYMEDP^8.08^', edtM6);
      SaveRadioGroup('TROUBLED^8.09^', rgrpM7, 0, 5, -1);
      SaveRadioGroup('IMPTMT^8.11^', rgrpM8, 0, 5, -1);
      if ((rgrpG8.ItemIndex = 0 {Full}) or (rgrpG8.ItemIndex = 2 {Followup})) then
        SaveRadioGroup('ISRMED^8.12^', rgrpM9, 0, 10, -1);
      SaveRadioGroup('MPATMISR^8.14^', rgrpM10, 0, 2, -1);
      SaveRadioGroup('MEDUNDER^8.15^', rgrpM11, 0, 2, -1);

  // Employment -----------------------------------------------------
      SaveEdit('EDUCYEAR^9.01^', edtE1y);
      SaveEdit('EDUCMONT^9.02^', edtE1m);
      SaveEdit('TRAINING^9.03^', edtE2);
      if rgrpG8.ItemIndex = 0 {Full} then
        begin
          SaveRadioGroup('PROFN^9.04^', rgrpE3, 0, 2, -1);
          if edtE3e.Enabled then
            SaveRzEdit('SPECPTS^9.05^', edtE3e);
        end;
      SaveRadioGroup('LICENSE^9.06^', rgrpE4, 0, 2, -1);
      if rgrpE5.Enabled then
        SaveRadioGroup('CAR^9.09^', rgrpE5, 0, 2, -1)
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('CAR^9.09^0^');
      if ((rgrpG8.ItemIndex = 0 {Full}) or (rgrpG8.ItemIndex = 1 {Lite})) then
        begin
          SaveEdit('JOBYEAR^9.11^', edtE6y);
          SaveEdit('JOBMONTH^9.12^', edtE6m);
        end;
      SaveRadioGroup('OCCUP^9.14^', rgrpE7, 1, -1, 9);
      SaveRzEdit('SPECOCCUP^9.145^', edtE7e);
      if ((rgrpG8.ItemIndex = 0 {Full}) or (rgrpG8.ItemIndex = 2 {Followup})) then
        SaveRadioGroup('SUPPORT^9.15^', rgrpE8, 0, 2, -1);
  // Item may be disabled, set to "N", see page 92, pink manual
      if rgrpE9.Enabled then
        SaveRadioGroup('MAJORITY^9.16^', rgrpE9, 0, 2, 3)
      else
        ASI_OPS.ChoicesMade.Add('MAJORITY^9.16^N^');
  //  end
  //else
  //  if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
  //    ASI_OPS.ChoicesMade.Add('MAJORITY^9.16^N^');
      if ((rgrpG8.ItemIndex = 0 {Full}) or (rgrpG8.ItemIndex = 1 {Lite})) then
        SaveRadioGroup('PATTERNS^9.17^', rgrpE10, 1, 8, 9);
      SaveEdit('DAYSPAID^9.18^', edtE11);
      SaveEdit('EMPL$^9.19^', edtE12);
      SaveEdit('UNEMPLOY^9.21^', edtE13);
      SaveEdit('DPA^9.22^', edtE14);
      SaveEdit('PENSION^9.23^', edtE15);
      SaveEdit('FAMILY^9.24^', edtE16);
      SaveEdit('ILLEGAL^9.25^', edtE17);
      SaveEdit('DEPENDS^9.29^', edtE18);
      if ((rgrpG8.ItemIndex = 0 {Full}) or (rgrpG8.ItemIndex = 2 {Followup})) then
        begin
          SaveEdit('EMPROB^9.31^', edtE19);
          SaveRadioGroup('EMPTROUB^9.32^', rgrpE20, 0, 5, 6);
        end;
      SaveRadioGroup('EMPCOUNS^9.33^', rgrpE21, 0, 5, 6);
      if ((rgrpG8.ItemIndex = 0 {Full}) or (rgrpG8.ItemIndex = 2 {Followup})) then
        SaveRadioGroup('EMPLOYRA^9.34^', rgrpE22, 0, 10, -1);
      SaveRadioGroup('EPATMISR^9.35^', rgrpE23, 0, 2, -1);
      SaveRadioGroup('EMPUNDER^9.36^', rgrpE24, 0, 2, -1);

 // Drug and Alcohol ------------------------------------------------
      SaveEdit('ALC30^10.01^', edtD1d);
      SaveEdit('ALCLIYR^10.02^', edtD1y);
      SaveComboBox('ALCRT^10.03^', cbxD1r, 1, 5, -1);
      SaveEdit('ALCIN30^10.04^', edtD2d);
      SaveEdit('ALCINLIY^10.05^', edtD2y);
      SaveComboBox('INTOXRT^10.06^', cbxD2r, 1, 5, -1);
      SaveEdit('HEROIN30^10.07^', edtD3d);
      SaveEdit('HERONLIY^10.08^', edtD3y);
      SaveComboBox('HERNRT^10.09^', cbxD3r, 1, 5, -1);
      SaveEdit('METHDN30^10.11^', edtD4d);
      SaveEdit('METDNLIY^10.12^', edtD4y);
      SaveComboBox('METHRT^10.14^', cbxD4r, 1, 5, -1);
      SaveEdit('OPIAT30^10.15^', edtD5d);
      SaveEdit('OPIATLIY^10.16^', edtD5y);
      SaveComboBox('OPIRT^10.17^', cbxD5r, 1, 5, -1);
      SaveEdit('BARB30^10.18^', edtD6d);
      SaveEdit('BARBLIFY^10.19^', edtD6y);
      SaveComboBox('BARBRT^10.21^', cbxD6r, 1, 5, -1);
      SaveEdit('SEDS30^10.22^', edtD7d);
      SaveEdit('SEDLIFYR^10.23^', edtD7y);
      SaveComboBox('SEDSRT^10.24^', cbxD7r, 1, 5, -1);
      SaveEdit('COCAN30^10.25^', edtD8d);
      SaveEdit('COCLIFYR^10.26^', edtD8y);
      SaveComboBox('COCAINRT^10.27^', cbxD8r, 1, 5, -1);
      SaveEdit('AMPH30^10.28^', edtD9d);
      SaveEdit('AMPLIFYR^10.29^', edtD9y);
      SaveComboBox('AMPRT^10.31^', cbxD9r, 1, 5, -1);
      SaveEdit('MJ30^10.32^', edtD10d);
      SaveEdit('MJLIFEYR^10.33^', edtD10y);
      SaveComboBox('MJRT^10.34^', cbxD10r, 1, 5, -1);
      SaveEdit('HALLU30^10.35^', edtD11d);
      SaveEdit('HALLIFYR^10.36^', edtD11y);
      SaveComboBox('HALRT^10.37^', cbxD11r, 1, 5, -1);
      SaveEdit('INHA30^10.38^', edtD12d);
      SaveEdit('INHALIYR^10.39^', edtD12y);
      SaveComboBox('INHALRT^10.41^', cbxD12r, 1, 5, -1);
      SaveEdit('GT130^10.42^', edtD13d);
      SaveEdit('GT1LIYR^10.43^', edtD13y);
      if ((rgrpG8.ItemIndex = 0 {Full}) or (rgrpG8.ItemIndex = 2 {Followup})) then
        if rgrpD14.ItemIndex <> -1 then
          SaveRadioGroupIII('MAJPROB^10.45^', rgrpD14);
      if rgrpG8.ItemIndex = 0 {Full} then
        begin
          if edtD15.Enabled then //See page 46, pink manual
            SaveEdit('LONGABST^11.01^', edtD15)
          else
            if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
              ASI_OPS.ChoicesMade.Add('LONGABST^11.01^N^');
          if edtD16.Enabled then //See page 46, pink manual
            SaveEdit('LASTABST^11.02^', edtD16)
          else
            if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
              ASI_OPS.ChoicesMade.Add('LASTABST^11.02^N^');
        end;
      if ((rgrpG8.ItemIndex = 0 {Full}) or (rgrpG8.ItemIndex = 2 {Followup})) then
        begin
          SaveEdit('DTS^11.03^', edtD17);
          SaveEdit('ODS^11.04^', edtD18);
        end;
      SaveEdit('ALCTXS^11.05^', edtD19);
      SaveEdit('DRUGTXS^11.06^', edtD20);
      if ((rgrpG8.ItemIndex = 0 {Full}) or (rgrpG8.ItemIndex = 2 {Followup})) then
        begin
          if edtD21.Enabled then
            SaveEdit('ALDETOX^11.07^', edtD21)
          else
            if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
              ASI_OPS.ChoicesMade.Add('ALDETOX^11.07^N^');
          if edtD22.Enabled then
            SaveEdit('DRUDETOX^11.08^', edtD22)
          else
            if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
              ASI_OPS.ChoicesMade.Add('DRUDETOX^11.08^N^');
        end;
      SaveEdit('ALCMONEY^11.09^', edtD23);
      SaveEdit('DRUMONEY^11.11^', edtD24);
      SaveEdit('OPDAYS^11.12^', edtD25);
      SaveEdit('ALPROBS^11.14^', edtD26);
      SaveEdit('DRUPROBS^11.15^', edtD27);
      if rgrpD28.Enabled then
        SaveRadioGroup('ALBOTHR^11.16^', rgrpD28, 0, 5, 6)
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('ALBOTHR^11.16^0^');
      if rgrpD29.Enabled then
        SaveRadioGroup('DRUGBOTH^11.17^', rgrpD29, 0, 5, 6)
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('DRUGBOTH^11.17^0^');
      if rgrpD30.Enabled then
        SaveRadioGroup('ALTMT^11.165^', rgrpD30, 0, 5, 6)
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('ALTMT^11.165^0^');
      if rgrpD31.Enabled then
        SaveRadioGroup('DRUTMT^11.175^', rgrpD31, 0, 5, 6)
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('DRUTMT^11.175^0^');
      if ((rgrpG8.ItemIndex = 0 {Full}) or (rgrpG8.ItemIndex = 2 {Followup})) then
        begin
          SaveRadioGroup('ISRALC^11.18^', rgrpD32, 0, 10, 11);
          SaveRadioGroup('ISRDRUG^11.185^', rgrpD33, 0, 10, -1);
        end;
      SaveRadioGroup('DAMISREP^11.19^', rgrpD34, 0, 2, -1);
      if rgrpD35.ItemIndex <> -1 then
        SaveRadioGroup('DAUNDER^11.21^', rgrpD35, 0, -1, -1);

 // Legal  ---------------------------------------------------------
      if ((rgrpG8.ItemIndex = 0 {Full}) or (rgrpG8.ItemIndex = 1 {Lite})) then
        SaveRadioGroup('CJINVOLV^14.01^', rgrpL1, 0, 2, -1);
      SaveRadioGroup('ONPROBAT^14.02^', rgrpL2, 0, 2, -1);
      SaveEdit('SHOPLIFT^14.03^', edtL3);
      SaveEdit('PAROLVIL^14.04^', edtL4);
      SaveEdit('DRUGCHAR^14.05^', edtL5);
      SaveEdit('FORGE^14.06^', edtL6);
      SaveEdit('WEAPONS^14.07^', edtL7);
      SaveEdit('B_N_E^14.08^', edtL8);
      SaveEdit('ROBBERY^14.09^', edtL9);
      SaveEdit('ASSAULT^14.11^', edtL10);
      SaveEdit('ARSON^14.12^', edtL11);
      SaveEdit('RAPE^14.14^', edtL12);
      SaveEdit('MURDER^14.15^', edtL13);
      SaveEdit('PROSTITU^14.16^', edtL14);
      SaveEdit('CONTEMPT^14.17^', edtL15);
      SaveEdit('OTHER^14.18^', edtL16);
      if edtL17.Enabled then // page 92 of pink book
        SaveEdit('CONVICTS^14.19^', edtL17)
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('CONVICTS^14.19^N^');
      SaveEdit('DISORDER^14.21^', edtL18);
      SaveEdit('DWI^14.22^', edtL19);
      SaveEdit('DRIVING^14.23^', edtL20);
      SaveEdit('INCARLI^14.24^', edtL21);
      if ((rgrpG8.ItemIndex = 0 {Full}) or (rgrpG8.ItemIndex = 2 {Followup})) then
        begin
          if edtL22.Enabled then
            SaveEdit('LASTINCA^14.25^', edtL22)
          else
            if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
              ASI_OPS.ChoicesMade.Add('LASTINCA^14.25^N^');
// Check proper answer for no crimes at all: Blank, "0", "N" ??
// This will be the same response for L25
          if rgrpL23.Enabled then
            begin
              if rgrpL23.ItemIndex <> -1 then
                SaveRadioGroupII('REASONIN^14.26^', rgrpL23)
            end
          else
            if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
              ASI_OPS.ChoicesMade.Add('REASONIN^14.26^N^');
        end;
      SaveRadioGroup('WAITRIAL^14.27^', rgrpL24, 0, 2, -1);
      if rgrpL25.Enabled then
        begin
          if rgrpL25.ItemIndex <> -1 then
            SaveRadioGroupII('REASTRIA^14.28^', rgrpL25)
        end
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('REASONIN^14.28^N^');
      if edtL26.Enabled then
        SaveEdit('DETAIN30^14.29^', edtL26)
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('DETAIN30^14.29^0^');
      SaveEdit('ILLDAY30^14.31^', edtL27);
      SaveRadioGroup('PRALEGAL^14.32^', rgrpL28, 0, 5, 6);
      SaveRadioGroup('PRACOUNS^14.33^', rgrpL29, 0, 5, 6);
      if ((rgrpG8.ItemIndex = 0 {Full}) or (rgrpG8.ItemIndex = 2 {Followup})) then
        SaveRadioGroup('ISRLEGAL^14.34^', rgrpL30, 0, 10, -1);
      SaveRadioGroup('LPMISREP^14.35^', rgrpL31, 0, 2, -1);
      SaveRadioGroup('LPTUNDER^14.36^', rgrpL32, 0, 2, -1);

  // Family History ---------------------------------------------------
      if rgrpG8.ItemIndex = 0 then // Full ASI
        begin
          SaveComboBox('FHMGM^15.01^', cbxH1a, 0, 2, 3);
          SaveComboBox('FHMGM^15.02^', cbxH1d, 0, 2, 3);
          SaveComboBox('FHMGM^15.03^', cbxH1p, 0, 2, 3);
          SaveComboBox('FHMGF^15.04^', cbxH2a, 0, 2, 3);
          SaveComboBox('FHMGF^15.05^', cbxH2d, 0, 2, 3);
          SaveComboBox('FHMGF^15.06^', cbxH2p, 0, 2, 3);
          SaveComboBox('FHMM^15.07^', cbxH3a, 0, 2, 3);
          SaveComboBox('FHMM^15.08^', cbxH3d, 0, 2, 3);
          SaveComboBox('FHMM^15.09^', cbxH3p, 0, 2, 3);
          SaveComboBox('FHMA^15.11^', cbxH4a, 0, 2, 3);
          SaveComboBox('FHMA^15.12^', cbxH4d, 0, 2, 3);
          SaveComboBox('FHMA^15.14^', cbxH4p, 0, 2, 3);
          SaveComboBox('FHMU^15.15^', cbxH5a, 0, 2, 3);
          SaveComboBox('FHMU^15.16^', cbxH5d, 0, 2, 3);
          SaveComboBox('FHMU^15.17^', cbxH5p, 0, 2, 3);
          SaveComboBox('FHFGM^15.18^', cbxH6a, 0, 2, 3);
          SaveComboBox('FHFGM^15.19^', cbxH6d, 0, 2, 3);
          SaveComboBox('FHFGM^15.21^', cbxH6p, 0, 2, 3);
          SaveComboBox('FHFGF^15.22^', cbxH7a, 0, 2, 3);
          SaveComboBox('FHFGF^15.23^', cbxH7d, 0, 2, 3);
          SaveComboBox('FHFGF^15.24^', cbxH7p, 0, 2, 3);
          SaveComboBox('FHFF^15.25^', cbxH8a, 0, 2, 3);
          SaveComboBox('FHFF^15.26^', cbxH8d, 0, 2, 3);
          SaveComboBox('FHFF^15.27^', cbxH8p, 0, 2, 3);
          SaveComboBox('FHFA^16.01^', cbxH9a, 0, 2, 3);
          SaveComboBox('FHFA^16.02^', cbxH9d, 0, 2, 3);
          SaveComboBox('FHFA^16.03^', cbxH9p, 0, 2, 3);
          SaveComboBox('FHFU^16.04^', cbxH10a, 0, 2, 3);
          SaveComboBox('FHFU^16.05^', cbxH10d, 0, 2, 3);
          SaveComboBox('FHFU^16.06^', cbxH10p, 0, 2, 3);
          SaveComboBox('FHIBB^16.07^', cbxH11a, 0, 2, 3);
          SaveComboBox('FHIBB^16.08^', cbxH11d, 0, 2, 3);
          SaveComboBox('FHIBB^16.09^', cbxH11p, 0, 2, 3);
          SaveComboBox('FHIBS^16.11^', cbxH12a, 0, 2, 3);
          SaveComboBox('FHIBS^16.12^', cbxH12d, 0, 2, 3);
          SaveComboBox('FHIBS^16.14^', cbxH12p, 0, 2, 3);
        end; // Full ASI

// Social ---------------------------------------------------------
      SaveRadioGroup('MARSTAT^17.01^', rgrpF1, 1, 6, -1);
      if rgrpG8.ItemIndex = 0 then // Full ASI
        begin
          SaveEdit('MARYRS^17.02^', edtF2y);
          SaveEdit('MARMOS^17.03^', edtF2m);
        end;
      SaveRadioGroup('MARSATF^17.04^', rgrpF3, 0, 3, 4);
      SaveRadioGroup('LIVARRGN^17.05^', rgrpF4, 1, 9, 10);
      if rgrpG8.ItemIndex = 0 then // Full ASI
        begin
          SaveEdit('LIVYRS^17.06^', edtF5y);
          SaveEdit('LIVMONTH^17.07^', edtF5m);
        end;
      SaveRadioGroup('LIVSATF^17.08^', rgrpF6, 0, 3, 4);
      SaveRadioGroup('LIVWALC^17.09^', rgrpF7, 0, 2, -1);
      SaveRadioGroup('LIVWDRUG^17.11^', rgrpF8, 0, 2, -1);
      if ((rgrpG8.ItemIndex = 0 {Full}) or (rgrpG8.ItemIndex = 2 {Followup})) then
        begin
          SaveRadioGroup('FREETIME^17.12^', rgrpF9, 1, 3, 4);
          SaveRadioGroup('FREESATF^17.14^', rgrpF10, 0, 3, 4);
          SaveEdit('CLOSFREN^17.15^', edtF11);
        end;
      if rgrpG8.ItemIndex = 0 then // Full ASI
        begin
          SaveComboBox('CLOSMOTR^17.16^', cbxF12, 0, 2, 3);
          SaveComboBox('CLOSFATR^17.17^', cbxF13, 0, 2, 3);
          SaveComboBox('CLOSSIBS^17.18^', cbxF14, 0, 2, 3);
          SaveComboBox('CLOSPRTN^17.19^', cbxF15, 0, 2, 3);
          SaveComboBox('CLOSKIDS^17.21^', cbxF16, 0, 2, 3);
          SaveComboBox('CLOSFREN^17.22^', cbxF17, 0, 2, 3);
        end;
      SaveRadioGroup('MOM30^18.01^', rgrpF18, 0, 2, 3);
      SaveRadioGroup('MOMLIFE^18.02^', rgrpF18l, 0, 2, 3);
      SaveRadioGroup('DAD30^18.03^', rgrpF19, 0, 2, 3);
      SaveRadioGroup('DADLIFE^18.04^', rgrpF19l, 0, 2, 3);
      SaveRadioGroup('SIBS30^18.05^', rgrpF20, 0, 2, 3);
      SaveRadioGroup('SIBSLIFE^18.06^', rgrpF20l, 0, 2, 3);
      SaveRadioGroup('SPOUS30^18.07^', rgrpF21, 0, 2, 3);
      SaveRadioGroup('SPOULIFE^18.08^', rgrpF21l, 0, 2, 3);
      SaveRadioGroup('KIDS30^18.09^', rgrpF22, 0, 2, 3);
      SaveRadioGroup('KIDSLIFE^18.11^', rgrpF22l, 0, 2, 3);
      SaveRadioGroup('OTHFAM30^18.12^', rgrpF23, 0, 2, 3);
      SaveRadioGroup('OTHFAMLI^18.14^', rgrpF23l, 0, 2, 3);
      if rgrpF24.Enabled then // See page 92 in pink manual
        SaveRadioGroup('FREN30^18.15^', rgrpF24, 0, 2, 3)
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('FREN30^18.15^N^');
      SaveRadioGroup('FRENLIFE^18.16^', rgrpF24l, 0, 2, 3);
      SaveRadioGroup('NEIGH30^18.17^', rgrpF25, 0, 2, 3);
      SaveRadioGroup('NEIGHLIF^18.18^', rgrpF25l, 0, 2, 3);
      if rgrpF26.Enabled then // See page 92 in pink manual
        SaveRadioGroup('COWOR30^18.185^', rgrpF26, 0, 2, 3)
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('COWOR30^18.185^N^');
      SaveRadioGroup('COWORLIF^18.186^', rgrpF26l, 0, 2, 3);
      if ((rgrpG8.ItemIndex = 0 {Full}) or (rgrpG8.ItemIndex = 2 {Followup})) then
        SaveRadioGroup('EMOABU30^18.19^', rgrpF27, 0, 2, 3);
      SaveRadioGroup('EMOABULI^18.195^', rgrpF27l, 0, 2, 3);
      SaveRadioGroup('PHYABU30^18.21^', rgrpF28, 0, 2, 3);
      SaveRadioGroup('PHYABULI^18.215^', rgrpF28l, 0, 2, 3);
      SaveRadioGroup('SEXABU30^18.22^', rgrpF29, 0, 2, 3);
      SaveRadioGroup('SEXABULI^18.225^', rgrpF29l, 0, 2, 3);
      SaveEdit('FAMCONFL^18.23^', edtF30);
      SaveEdit('OTHCONFL^18.24^', edtF31);
      SaveRadioGroup('PRAFPROB^18.25^', rgrpF32, 0, 5, 6);
      if ((rgrpG8.ItemIndex = 0 {Full}) or (rgrpG8.ItemIndex = 2 {Followup})) then
        SaveRadioGroup('PRASPROB^18.26^', rgrpF33, 0, 5, 6);
      SaveRadioGroup('FAMTMT^18.27^', rgrpF34, 0, 5, 6);
      if ((rgrpG8.ItemIndex = 0 {Full}) or (rgrpG8.ItemIndex = 2 {Followup})) then
        begin
          SaveRadioGroup('SOCTMT^18.28^', rgrpF35, 0, 5, 6);
          SaveRadioGroup('ISRFS^18.29^', rgrpF36, 0, 10, -1);
        end;
      SaveRadioGroup('FSMISREP^18.31^', rgrpF37, 0, 2, -1);
      SaveRadioGroup('FSPUND^18.32^', rgrpF38, 0, 2, -1);

// Psych ----------------------------------------------------------
      SaveEdit('INPSYC^19.01^', edtP1a);
      SaveEdit('OUTPSYC^19.02^', edtP1b);
      SaveRadioGroup('PSYCPEN^19.03^', rgrpP2, 0, 2, -1);
      SaveRadioGroup('DEPR30^19.04^', rgrpP3, 0, 2, -1);
      SaveRadioGroup('DEPRLIFE^19.05^', rgrpP3l, 0, 2, -1);
      SaveRadioGroup('ANXT30^19.06^', rgrpP4, 0, 2, -1);
      SaveRadioGroup('ANXTLIFE^19.07^', rgrpP4l, 0, 2, -1);
      SaveRadioGroup('HALL30^19.08^', rgrpP5, 0, 2, -1);
      SaveRadioGroup('HALLLIFE^19.09^', rgrpP5l, 0, 2, -1);
      SaveRadioGroup('UNDER30^19.11^', rgrpP6, 0, 2, -1);
      SaveRadioGroup('UNDERLIF^19.12^', rgrpP6l, 0, 2, -1);
      SaveRadioGroup('VIOL30^19.14^', rgrpP7, 0, 2, -1);
      SaveRadioGroup('VIOLLIFE^19.15^', rgrpP7l, 0, 2, -1);
      SaveRadioGroup('SUITH30^19.16^', rgrpP8, 0, 2, -1);
      SaveRadioGroup('SUITHLIF^19.17^', rgrpP8l, 0, 2, -1);
      SaveRadioGroup('SUIAT30^19.18^', rgrpP9, 0, 2, -1);
      SaveRadioGroup('SUIATLIF^19.19^', rgrpP9l, 0, 2, -1);
      SaveRadioGroup('PMED30^19.21^', rgrpP10, 0, 2, -1);
      SaveRadioGroup('PMEDLIFE^19.22^', rgrpP10l, 0, 2, -1);
      SaveEdit('PSYCDAYS^19.23^', edtP11);
      SaveRadioGroup('PRATPSY^19.24^', rgrpP12, 0, 5, -1);
      SaveRadioGroup('PSYTMT^19.25^', rgrpP13, 0, 5, -1);
      if ((rgrpG8.ItemIndex = 0 {Full}) or (rgrpG8.ItemIndex = 2 {Followup})) then
        begin
          SaveRadioGroup('DEPNOW^19.26^', rgrpP14, 0, 2, -1);
          SaveRadioGroup('HOSTNOW^19.27^', rgrpP15, 0, 2, -1);
          SaveRadioGroup('ANXNOW^19.28^', rgrpP16, 0, 2, -1);
          SaveRadioGroup('REALNOW^19.29^', rgrpP17, 0, 2, -1);
          SaveRadioGroup('COMPRNOW^19.31^', rgrpP18, 0, 2, -1);
          SaveRadioGroup('SUICNOW^19.32^', rgrpP19, 0, 2, -1);
          SaveRadioGroup('ISRPSYC^19.33^', rgrpP20, 0, 10, -1);
        end;
      SaveRadioGroup('PMISREP^19.34^', rgrpP21, 0, 2, -1);
      SaveRadioGroup('PSPUND^19.35^', rgrpP22, 0, 2, -1);

      //if ASI_OPS.SaveChoicesMade <> BAD_DATA then
      TempIENS := ASI_OPS.SaveChoicesMade(
        aRecordIENS <> NO_ID,
        aRecordIENS,
        aPatientDFN,
        aDate,
        aInterviewerDUZ,
        aOrderedbyDUZ,
        aInterviewType);

      // When successful this is returned:
      // "OK ASI SAVED XXXX," where XXXX is the RecordIEN

        if TempIENS <> BAD_DATA then
        begin
          try
        // Save Comments, these are memo fields
            SaveCommentField(memGeneral, '.6');
            SaveCommentField(memMedical, '8.5');
            SaveCommentField(memEmploy, '9.5');
            SaveCommentField(memDrug, '10.5');
            SaveCommentField(memLegal, '14.5');
            SaveCommentField(memFamily, '16.5');
            SaveCommentField(memSocial, '18.5');
            SaveCommentField(memPsych, '19.5');
            SaveCommentField(memLeisure, '187');
            SaveCommentField(memSpirit, '188');
        // Update "saves" data from ALL controls SaveComboBoxed using SaveComboBoxChgdControl in
        // SaveCommentField
            if DataModule1.FMFiler1.Update then
            else
              DataModule1.FMFiler1.DisplayErrors;
          finally;
          end;
        end
      else
        Result := 'The ASI was not saved in the VistA database. Please try to save it again.';

      if not FASITimedOut then
        begin
          Screen.Cursor := crDefault;
          lblHint.Caption := 'Data saved. Closing this ASI.';
        end;

    end;

end;


end.

