unit uMHA_Answer_IO;

interface

uses
  Classes,
  Windows,
  SysUtils,
  System.Contnrs,
  uMHA_Administration,
  Trpcb;

function ReadAnswers(aAdmin: TAdministration;
  Broker: TRPCBroker): string;
function WriteAnswers(aAdmin: TAdministration;
  Broker: TRPCBroker): Boolean;
function AnswerReadComment(AFile: string; AField: string;
  AIENS: string;
  Broker: TRPCBroker): string;


implementation

uses
  uIA_Const,
  uMHA_Const,
  fIA_dialogs, Dialogs,
  fMHA_Progress,
  uIA_Utils,
  uIA_Patient,
  uIA_ThisUser,
  uMHA_LocalFiles,
  uIA_Answer;


function WriteAnswers(aAdmin: TAdministration;
  Broker: TRPCBroker): Boolean;
// Not to be used with ASI's
var
  i, j                        : integer;
  YS,
    FileName,
    TempAns,
    TempStr                   : string;
//  SString,
  TempStrList                 : TStringList;

begin
  Result := False;

// Debug/Development string list, saved to file
//   SSTring := TStringList.create;

  case DataBaseMode of
    dbVista:
      begin
        frmMHA_Progress := TfrmMHA_Progress.Create(nil);
        try
          frmMHA_Progress.SetupProgressBar(aAdmin.InstrumentName + ': Saving answers. . .',
            aAdmin.ListOfAdminAnswers.Count);

          with Broker do
            begin
              ClearParameters := True;
              ClearResults := True;
              CreateContext('YS BROKER1');
              //* LocalFiles.UpdateAPILog('Call to YTQ SET ANSWER ALL: AD=' + aAdmin.ID);
              Remoteprocedure := 'YTQ SET ANSWER ALL';

//              SString.Add('Param[0].Mult["AD"] := ' + aAdmin.ID);

              YS := '"AD"';
              Param[0].Mult[YS] := aAdmin.ID;

              for i := 1 to aAdmin.ListOfAdminAnswers.Count do
                begin
                  frmMHA_Progress.IncreaseProgressBar;

                  if TAnswer(aAdmin.ListOfAdminAnswers[i - 1]).IsMultiChoice then
                  // Note: CheckList is not considered multichoice
                    begin
                      // Save AnswerValue when skipped, not asked, etc.
                      if (TAnswer(aAdmin.ListOfAdminAnswers[i - 1]).AnswerValue = NOT_ASKED) or
                        (TAnswer(aAdmin.ListOfAdminAnswers[i - 1]).AnswerValue =
                        CHOICE_ID_OF_SKIPPED_QUESTION) or
                        (TAnswer(aAdmin.ListOfAdminAnswers[i - 1]).AnswerValue =
                        CHOICE_ID_OF_SKIPPED_BY_RULE_QUESTION) or
                        (TAnswer(aAdmin.ListOfAdminAnswers[i - 1]).AnswerValue =
                        CHOICE_ID_OF_SKIPPED_REQUIRED_QUESTION) then
                        begin
                          TempAns := TAnswer(aAdmin.ListOfAdminAnswers[i - 1]).AnswerValue;
                        end
                      else
                        begin
                         // otherwise save ChoiceID
                          TempAns := TAnswer(aAdmin.ListOfAdminAnswers[i - 1]).AnswerChoiceID;
                        end;

//                      SString.Add('Param[0].Mult["' + IntToStr(i) + '"] := ' +
//                        TAnswer(aAdmin.ListOfAdminAnswers[i - 1]).QuestionID + U +
//                        TempAns);

                      YS := '"' + IntToStr(i) + '"'; // Quotes are needed
                      Param[0].Mult[YS] :=
                        TAnswer(aAdmin.ListOfAdminAnswers[i - 1]).QuestionID + U +
                        TempAns
                    end

                  else
                  // Not multiChoice:
                  //   Date fields, edit, spin-edit, check-list (text of checked items)
                  //   Blank fields were set to BLANK, i.e., 'Left blank by the user.'
                  //   see HandleBlankFields within SaveAllAnswers
                    begin
                      TempStr := '';
                      // Remove any control characters in string; replace carriage returns with its
                      // marker (Vista can not handle #13 and #10).
                      TempStr := RemoveControlChar(TAnswer(aAdmin.ListOfAdminAnswers[i - 1]).AnswerText);
                      TempStr := StringToPieces(TempStr, U, 200);

//                      SString.Add('Param[0].Mult["' + IntToStr(i) + '"] := ' +
//                        TAnswer(aAdmin.ListOfAdminAnswers[i - 1]).QuestionID);

                      YS := '"' + IntToStr(i) + '"';
                      Param[0].Mult[YS] :=
                        TAnswer(aAdmin.ListOfAdminAnswers[i - 1]).QuestionID;

                      for j := 1 to NumberOfPieces(TempStr, U) do
                        begin
                          // Eventhough this is not in the same format as above, do NOT
                          // change it.
                          YS := IntToStr(i) + ',' + IntToStr(j); // No quotes. right
                          Param[0].Mult[YS] := Piece(TempStr, U, j);

//                          SString.Add('Param[0].Mult[' + IntToStr(i) + ',' +
//                            IntToStr(j) + '] := ' + Piece(TempStr, U, j));
                        end; // for j

                    end; // MultiChoice
                end; // for i

//              sstring.SaveToFile('SET_SAVE.TXT');
//              sstring.FREE;

              Param[0].PType := List;

              try
                Call;

              except
                on E: EBrokerError do
                  begin
                    //* LocalFiles.UpdateAPILog('Call to YTQ SET ANSWER ALL: Error ');
                    //* LocalFiles.UpdateAPILog('   ' + 'Broker Error: ' + E.message);
                    exit;
                  end;
                on E: EAccessViolation do
                  begin
                    //* LocalFiles.UpdateAPILog('Call to YTQ SET ANSWER ALL: Error ');
                    //* LocalFiles.UpdateAPILog('   ' + 'Access Violation: ' + E.message);
                    exit;
                  end;
              end; // try

              if Results[0] <> DATA then
                begin
                  //* LocalFiles.UpdateAPILog('Call to YTQ SET ANSWER ALL: Error');
                  //* for j := 0 to Results.Count - 1 do
                    //* LocalFiles.UpdateAPILog('   ' + Results[j]);
                  Exit;
                end;
              //* else
                //* LocalFiles.UpdateAPILog('Call to YTQ SET ANSWER ALL: Successful');

            end; // with
        finally
          frmMHA_Progress.Free;
        end; //try
        Result := True;
      end; // dbVista

    dbOffLine:
      begin
        FileName := LocalFiles.AnswerFileName(Patient.DFN, aAdmin.ID);
        TempStrList := TStringList.Create;

        for j := 0 to aAdmin.ListOfAdminAnswers.Count - 1 do
          TempStrList.Add(
            TAnswer(aAdmin.ListOfAdminAnswers[j]).QuestionID + U +
            // Saving ItemIndex, if MultiChoice
            TAnswer(aAdmin.ListOfAdminAnswers[j]).AnswerValue + U +
            TAnswer(aAdmin.ListOfAdminAnswers[j]).AnswerText + U +
            TAnswer(aAdmin.ListOfAdminAnswers[j]).AnswerLegacyValue + U +
            BoolToMStr(TAnswer(aAdmin.ListOfAdminAnswers[j]).IsMultiChoice) + U +
            IntToStr(TAnswer(aAdmin.ListOfAdminAnswers[j]).AnswerItemIndex) + U +
            TAnswer(aAdmin.ListOfAdminAnswers[j]).AnswerChoiceID + U);

        TempStrList.SaveToFile(FileName);
        TempStrList.Free;

        Result := True;
      end; // Off-line
  end; //case DataBaseMode
end;


function ReadAnswers(aAdmin: TAdministration;
  Broker: TRPCBroker): string;
var
  TempStr, NewQID, OldQID     : string;
  i, j                        : integer;
  AnswerStr                   : TStringList;
begin
  Result := OK;
  TempStr := '';

  case DataBaseMode of
    dbVista:
      begin
        with Broker do
          begin

            ClearParameters := True;
            ClearResults := True;
            CreateContext('YS BROKER1');
            //* LocalFiles.UpdateAPILog('Call to YTQ ALL ANSWERS: AD=' + aAdmin.ID);
            RemoteProcedure := 'YTQ ALL ANSWERS';

            Param[0].Mult['"AD"'] := aAdmin.ID;
            Param[0].PType := List;
            try
              Call;

            except
              on E: EBrokerError do
                begin
                  //* LocalFiles.UpdateAPILog('Call to YTQ ALL ANSWERS: Error ');
                  //* LocalFiles.UpdateAPILog('   ' + 'Broker Error: ' + E.message);
                  exit;
                end;
              on E: EAccessViolation do
                begin
                  //* LocalFiles.UpdateAPILog('Call to YTQ ALL ANSWERS: Error ');
                  //* LocalFiles.UpdateAPILog('   ' + 'Access Violation: ' + E.message);
                  exit;
                end;
            end; // try

            // Output: QUESTION ID^Sequence Number^ANSWER
            // Where ANSWER is ChoiceID for Multi-choice items, text for others
            // (This will be sorted out later.)
            // If there are blank items saved to Vista, they will not come back here
            // Thus, do not trust the results sequence to be the same as the
            // ListOfAnswers

            if Results.Count < 2 then
              begin
                Result := BAD_DATA;
                //* LocalFiles.UpdateAPILog('Call to YTQ ALL ANSWERS: Error');
                //* for i := 0 to Results.Count - 1 do
                  //* LocalFiles.UpdateAPILog('   ' + Results[i]);
                Exit;
              end;

            AnswerStr := TStringList.Create;
            OldQID := '';
            i := -1;

            for j := 2 to Results.Count - 1 do
              begin
                NewQID := Piece(Results[j], U, 1);
                // For long text answers the next chunk of 200 chars are in
                // the next results[j].
                if (NewQID = OldQID) then
                 begin
                  AnswerStr[i] := AnswerStr[i] + Piece(Results[j], U, 3);
                  // A space is not needed here, the string is fixed at 200 characters.
                  end
                else
                  begin
                    Inc(i);
                    AnswerStr.Add(Piece(Results[j], U, 1) + U +
                      Piece(Results[j], U, 3));
                    OldQID := NewQID;
                  end; //else
              end; // for j

            for j := 0 to AnswerStr.Count - 1 do
              begin
                for i := 0 to aAdmin.ListOfAdminAnswers.Count - 1 do
                  begin
                    if Piece(AnswerStr[j], U, 1) =
                      TAnswer(aAdmin.ListOfAdminAnswers[i]).QuestionID then
                      begin
                        TAnswer(aAdmin.ListOfAdminAnswers[i]).AnswerValue :=
                          Piece(AnswerStr[j], U, 2);
                        TAnswer(aAdmin.ListOfAdminAnswers[i]).AnswerChoiceID :=
                          Piece(AnswerStr[j], U, 2);
                        TAnswer(aAdmin.ListOfAdminAnswers[i]).AnswerText :=
                          Piece(AnswerStr[j], U, 2);
                        Break;
                      end;
                  end; // for i

              end; // for j

            AnswerStr.Free;
            //* LocalFiles.UpdateAPILog('Call to YTQ ALL ANSWERS: Successful');
          end; //with DataModule1.RPCBroker1
      end; //case dbVista

    dbOffLine:
      begin
        AnswerStr := TStringList.Create;
        TempStr := LocalFiles.AnswerFileName(Patient.DFN, aAdmin.ID);

        if FileExists(TempStr) then
          AnswerStr.LoadFromFile(TempStr)
        else
          begin
            Result := BAD_DATA;
            Exit;
          end;

        for i := 0 to AnswerStr.Count - 1 do
          begin
            TAnswer(aAdmin.ListOfAdminAnswers[i]).QuestionID :=
              Piece(AnswerStr[i], U, 1);
            TAnswer(aAdmin.ListOfAdminAnswers[i]).AnswerValue :=
              Piece(AnswerStr[i], U, 2); // ItemIndex for MultiChoice items
            TAnswer(aAdmin.ListOfAdminAnswers[i]).AnswerText :=
              Piece(AnswerStr[i], U, 3); // ItemIndex for MultiChoice items
            TAnswer(aAdmin.ListOfAdminAnswers[i]).AnswerLegacyValue :=
              Piece(AnswerStr[i], U, 4);
            TAnswer(aAdmin.ListOfAdminAnswers[i]).IsMultiChoice :=
              Piece(AnswerStr[i], U, 5) = 'YES';
            TAnswer(aAdmin.ListOfAdminAnswers[i]).AnswerItemIndex :=
              StrToIntDef(Piece(AnswerStr[i], U, 6), -1);
            TAnswer(aAdmin.ListOfAdminAnswers[i]).AnswerChoiceID :=
              Piece(AnswerStr[i], U, 7);
          end;

        AnswerStr.Free;

      end; //case dbOffLine
  end; //case DataBaseMode
end;


function AnswerReadComment(AFile: string; AField: string;
  AIENS: string;
  Broker: TRPCBroker): string;
var
  i                           : integer;
  tmpString                   : string;
begin
  if not (DataBaseMode = dbVista) then
    begin
      Result := BAD_DATA;
      Exit;
    end;

  with Broker do
    begin

      ClearParameters := True;
      ClearResults := True;
      CreateContext('YS BROKER1');
      //* LocalFiles.UpdateAPILog('Call to YTQ CAPIE:' +
      //*   ' FILEN=' + AFile +
      //*   ' FIELDS=' + AField +
      //*   ' IENS=' + AIENS);
      RemoteProcedure := 'YTQ CAPIE';
      Param[0].Mult['"FILEN"'] := AFile;
      Param[0].Mult['"FIELDS"'] := AField;
      Param[0].Mult['"IENS"'] := AIENS;
      Param[0].PType := List;

      try
        Call;

      except
        on E: EBrokerError do
          begin
            //* LocalFiles.UpdateAPILog('Call to YTQ CAPIE: Error ');
            //* LocalFiles.UpdateAPILog('   ' + 'Broker Error: ' + E.message);
            exit;
          end;
        on E: EAccessViolation do
          begin
            //* LocalFiles.UpdateAPILog('Call to YTQ CAPIE: Error ');
            //* LocalFiles.UpdateAPILog('   ' + 'Access Violation: ' + E.message);
            exit;
          end;
      end; // try

      if not (Results[0] = DATA) then
        begin
          Result := BAD_DATA;
          //* LocalFiles.UpdateAPILog('Call to YTQ CAPIE: Error');
          //* for i := 0 to Results.Count - 1 do
            //* LocalFiles.UpdateAPILog('   ' + Results[i]);
          Exit;
        end;
      //* else
        //* LocalFiles.UpdateAPILog('Call to YTQ CAPIE: Successful');

      tmpString := '';
      for i := 1 to Results.Count - 1 do
        tmpString := tmpString + Piece(Results[i], U, 3) + U;

    end;

  Result := DropTrailer(tmpString);

end;

end.


