unit uMHA_Proctor;

interface

type
  TDataEntryMode = (emStaff, emPatient);
  TCloseOption = (coSign, coCancel, coFinishLater);
  //For now, coSign is not being used for signing.

type
  TProctor = class
    DataEntryMode: TDataEntryMode;
    CloseOption: TCloseOption;
  private

  protected
  public
    destructor Destroy; override;
    constructor Create;
    procedure LoadCloseOption(AnOption: Char);

  end; { TProctor }

var
  Proctor                     : TProctor;

implementation

destructor TProctor.Destroy;
begin
  inherited Destroy;
end;

constructor TProctor.Create;
begin
  inherited Create;
end;

procedure TProctor.LoadCloseOption(AnOption: Char);
begin
  case AnOption of
    'C': CloseOption := coCancel;
    'S': CloseOption := coSign;
    'F': CloseOption := coFinishLater;
  else
    CloseOption := coCancel;
  end;
end;

initialization
  Proctor := TProctor.Create;

finalization
  Proctor.Free;

end.

