library YS_MHA_A;

{* This version is a two state model: the user is presented the desired
   instrument that can be filled in according to business rules, etc. A
   temporary global in Vista.

   A second call to this dll will save the instrument results to Vista.

   This version also has the latest object upgrades for MHA3.


  Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. *}

uses
  ShareMem,
  SysUtils,
  Classes,
  uMHA_DLL in 'uMHA_DLL.pas',
  uMHA_DLL_Const in 'uMHA_DLL_Const.pas',
  uIA_Instrument_IO in '..\IA Core\uIA_Instrument_IO.pas',
  uIA_Keys_IO in '..\IA Core\uIA_Keys_IO.pas',
  uIA_MultiChoice_IO in '..\IA Core\uIA_MultiChoice_IO.pas',
  uMHA_DLL_Registry in 'uMHA_DLL_Registry.pas',
  uIA_Rule_IO in '..\IA Core\uIA_Rule_IO.pas',
  uIA_Scales_IO in '..\IA Core\uIA_Scales_IO.pas',
  uIA_SectionLabel_IO in '..\IA Core\uIA_SectionLabel_IO.pas',
  fMHA_DLL_DataEntry in 'fMHA_DLL_DataEntry.pas' {frmMHA_DLL_DataEntry},
  uMHA_DLL_Vista_IO in 'uMHA_DLL_Vista_IO.pas',
  fMHA_DLL_GAF in 'fMHA_DLL_GAF.pas' {frmMHA_DLL_GAF},
  uMHA_DLL_GAF_List in 'uMHA_DLL_GAF_List.pas',
  uMHA_DLL_GAF_IO in 'uMHA_DLL_GAF_IO.pas',
  uIA_Utils in '..\IA Core\uIA_Utils.pas',
  fIA_Dialogs in '..\IA Core\fIA_Dialogs.pas',
  uIA_Answer in '..\IA Core\uIA_Answer.pas',
  uIA_Build in '..\IA Core\uIA_Build.pas',
  uIA_Const in '..\IA Core\uIA_Const.pas',
  uIA_Display in '..\IA Core\uIA_Display.pas',
  uIA_GUIControl in '..\IA Core\uIA_GUIControl.pas',
  uIA_Instrument in '..\IA Core\uIA_Instrument.pas',
  uIA_Introduction in '..\IA Core\uIA_Introduction.pas',
  uIA_Key in '..\IA Core\uIA_Key.pas',
  uIA_Rule in '..\IA Core\uIA_Rule.pas',
  uIA_Rule_OPS in '..\IA Core\uIA_Rule_OPS.pas',
  uIA_Scale in '..\IA Core\uIA_Scale.pas',
  uIA_ScaleGroup in '..\IA Core\uIA_ScaleGroup.pas',
  uIA_Scripts in '..\IA Core\uIA_Scripts.pas',
  uIA_SectionLabel in '..\IA Core\uIA_SectionLabel.pas',
  uIA_Question in '..\IA Core\uIA_Question.pas',
  uMHA_DLL_Score_IO in 'uMHA_DLL_Score_IO.pas',
  uIA_Patient_OPS in '..\IA Core\uIA_Patient_OPS.pas',
  uIA_Patient in '..\IA Core\uIA_Patient.pas',
  uIA_Patient_IO in '..\IA Core\uIA_Patient_IO.pas',
  uMHA_DLL_Instrument_OPS in 'uMHA_DLL_Instrument_OPS.pas',
  uIA_Question_IO in '..\IA Core\uIA_Question_IO.pas',
  uIA_Question_OPS in '..\IA Core\uIA_Question_OPS.pas',
  uIA_Consult_OPS in '..\IA Core\uIA_Consult_OPS.pas',
  uIA_Consult_IO in '..\IA Core\uIA_Consult_IO.pas';

{$R *.RES}

exports
  ShowInstrument,
  SaveInstrument,
  RemoveTempFile,
  RemoveTempVistaFile,
  CloseDLL;

begin

end.

