unit uMHA_DLL_GAF;

interface

uses
  Classes,
  Controls,
  Fmcntrls,
  DateUtils,
  SysUtils;

type
  TGAF = class
  private
    FIsSaved: BOOLEAN;
    FRater: string;
    FRating: Integer;
    FIENS: string;
    FDate: TDate;
    FEnteredInError: BOOLEAN;
    FUserCanModify: BOOLEAN;
    FCanBeMarkedInError: BOOLEAN;
    FCanBeEdited: BOOLEAN;
    FDateString: string;
    FCanBeModified: BOOLEAN;
  protected
  public
    procedure Clear;
    procedure Load(ARecord: string);

    property IsSaved: BOOLEAN read FIsSaved write FIsSaved;
    property Rating: Integer read FRating write FRating;
    property Rater: string read FRater write FRater;
    property Date: TDate read FDate write FDate;
    property IENS: string read FIENS write FIENS;
    property EnteredInError: BOOLEAN read FEnteredInError write FEnteredInError;
    property CanBeMarkedInError: BOOLEAN read FCanBeMarkedInError write
      FCanBeMarkedInError;
    property CanBeEdited: BOOLEAN read FCanBeEdited write FCanBeEdited;
    property DateString: string read FDateString write FDateString;
    property CanBeModified: BOOLEAN read FCanBeModified write FCanBeModified;
  end; { TGAF }

var
  GAF: TGAF;

implementation

uses
  uIA_Utils,
  uIA_Const,
  uMHA_DLL_Const,
  uMHA_DLL_GAF_IO;

procedure TGAF.Clear;
begin
  FIsSaved := True;
  FIENS := '';
  FDate := Now;
  FDateString := DateToStr(FDate);
  FRating := 1;
  FRater := '';
  FEnteredInError := False;
  FUserCanModify := False;
  FCanBeMarkedInError := False;
  FCanBeEdited := False;
  FCanBeModified := False;
end;

procedure TGAF.Load(ARecord: string);
var
  tmpRecord, tmpRaterDUZ: string;
begin

  Clear;

  tmpRecord := ARecord;
  //  //11358=01/12/2004^85^11678^MHPROVIDER,ONE^ERROR

  FIENS := Piece(ARecord, EQ, 1);
  tmpRecord := Piece(ARecord, EQ, 2);

  FDate := StrToDate(Piece(Piece(tmpRecord, U, 1), '@', 1));

  FDateString := DateToStr(FDate);

  FRating := StrToIntDef(Piece(tmpRecord, U, 2), 1);
  if (FRating > 100) then
    FRating := 100;

  tmpRaterDUZ := Piece(tmpRecord, U, 3);

  FRater := Piece(tmpRecord, U, 4);

  FEnteredInError := (Piece(tmpRecord, U, 5) = 'ERROR');

  FUserCanModify := (tmpRaterDUZ = gvOrderedByDUZ)
    and not FEnteredInError;

  FCanBeEdited := FUserCanModify and (DaysBetween(FDate, Now) < 3);
  FCanBeMarkedInError := FUserCanModify and not FCanBeEdited;
  FCanBeModified := FCanBeEdited or FCanBeMarkedInError;

end;

(*procedure TGAF.SaveNew(ADFN: string; ADUZ: string; AUserName: string);
begin
  WriteNewGAFRating(ADFN, ADUZ, AUserName);
end;

procedure TGAF.MarkInError(ADFN: string; AUserName: string);
begin
  WriteGAFEnteredInError(ADFN, AUserName);
end;

procedure TGAF.Delete(ADFN: string);
begin
  DeleteGAF(ADFN);
end;

procedure TGAF.SaveEdit(ADFN: string);
begin
  WriteEditedGAFRating(ADFN)
end; *)

end.

