unit uMHA_DLL_Score_IO;

interface

uses
  SysUtils,
  Dialogs,
  Trpcb;

function GetLegacyScores(Broker: TRPCBroker;
  aInstrument,
  aMDate,
  aPatientDFN,
  aOrderedByDUZ,
  aLegacyAnswerString: string): string;


implementation

uses
  uIA_Const,
  uMHA_DLL_Const,
  uIA_Utils;


function GetLegacyScores(Broker: TRPCBroker;
  aInstrument,
  aMDate,
  aPatientDFN,
  aOrderedByDUZ,
  aLegacyAnswerString: string): string;
var
  i                           : Integer;
  Scores                      : Boolean;
begin
  result := '';
  scores := True;

  with Broker do
    begin
      ClearParameters := True;
      ClearResults := True;
      CreateContext('YS BROKER1');
      RemoteProcedure := 'YTQ LEGCR';

      Param[0].Mult['"CODE"'] := aInstrument;
      Param[0].Mult['"ADATE"'] := aMDate;
      Param[0].Mult['"DFN"'] := aPatientDFN;
      Param[0].Mult['"STAFF"'] := aOrderedByDUZ;
      Param[0].Mult['"R1"'] := Copy(aLegacyAnswerString, 1, 200);
      Param[0].Mult['"R2"'] := Copy(aLegacyAnswerString, 201, 400);
      Param[0].Mult['"R3"'] := Copy(aLegacyAnswerString, 401, 600);
      Param[0].PType := List;

      Call;

      if Results.Count < 10 then
        begin
          Result := 'ERROR in API call: YTQ LEGCR';
          Exit;
        end;

      // Each scale and its score has a line in results starting at 5
      // 1^Scale1 name^ Scale1 Score
      // 2^Scale2 name^ Scale2 score ...

      for i := 5 to Results.Count - 1 do
        begin

          if Results[i] = '^^PROGRESS NOTE^^' then
            begin
              results[i] := '^';
              scores := False;
            end;
          if Scores then
            begin
              result := result + '*' + piece(results[i], U, 3) + '~' +
                piece(results[i], U, 4);
              if (numberOfPieces(results[i], U) > 4) and
                (piece(results[i], U, 5) <> '') then
                result := result + '~' + piece(results[i], U, 5);
            end;
          //else
            //result := result + results[i] + FILE_NAME_DELIMITER {~};
        end;

      CreateContext('OR CPRS GUI CHART');
    end; // Broker
end;

end.

