unit uMHA_AUX_CAM;

//patch 129 llh - corrected spelling error, from deliruim to delirium, all occurrences

interface

uses
  SysUtils;

function ScoreAnswers_CAM(
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;

function ProgressNote_CAM(
  PatientName,
  PatientDOB,
  PatientSex,
  ScoreString,
  AnswerString: string): string;

implementation

uses
  uMHA_AUX_Const,
  //patch 129 removed fIA_dialogs,
  //fIA_dialogs,
  uMHA_AUX_Utils,
  dialogs;


{*
  The format for output is used by Clinical reminders as their preferred method.
  The second field in the output is the Scale IEN, which is not used in IAT.

  //  CHANGE THIS..... make it pertinent to CAM

  Question 1a must be YES.
  Question 2 must = 1 or 2
  Question 3 must = 1
  Question 4 has to be anything other than zero.

  If all these conditions are met, then a deliruim diagnosis is supported.


*}

// llh testing timestamps

function ScoreAnswers_CAM(
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;

var
  Q1, Q2A, Q3A, Q4A,
    Q2B, Q3B, Q4B              : integer;
  Count, i,
    TempAnswer                 : Integer;

  skip1, skip2, skip3,
    skip6, skip9               : Boolean ;

  CAM_Result,
    TempResult, ansSkipped
                                : string;
begin
  // AnswerString Format:
  //      83=1^1330~
  //      84=0^214~...
  //
  // '83' is QuestionID,
  // '1' is ItemIndex for radio group, but can be text from edit field
  // '1130' is ChoiceID (not used here)

  // This is used by InstrumentResults to do a quick check on the
  // instrument as to its use of the dll

  if AnswerString = 'CAM' then
    begin
      Result := 'YES';
      exit;
    end;

  Result := '';
  Count := NumberOfPieces(AnswerString, RECORD_END);
  CAM_Result := 'Questions 1-4 not answered, no determination could be made.';
  skip1 := false ;
  skip2 := false ;
  skip3 := false ;
  skip6 := false ;
  skip9 := false ;
  Q1  := 0;
  Q2A := 0;
  Q3A := 0;
  Q4A := 0;
  Q2B := 0;
  Q3B := 0;
  Q4B := 0;

// scoring logic as of 08/21/2013, numeric values are item index values
// if ( (1a = Y ) AND ( 2b or 3b or 4b = Yes ) AND ( 2a = 1 or 2 ) )  AND
//    ( (3a = 1 or 2) OR (4a = 1 or 2 or 3 or 4)) = probable delirium
// if ( (1a = Y ) AND ( 2b or 3b or 4b = No, Uncertain, Not Applicable ) AND (2a = 1 or 2 ) )  AND
//    ( (3a = 1 or 2) OR (4a = 1 or 2 or 3 or 4)) = possible delirium


  if Count < 1 then
    Exit;

  for i := 1 to Count - 1 do
    begin
      TempResult := Piece(AnswerString, RECORD_END, i);
      TempAnswer := StrToIntDef(Piece(Piece(TempResult, U, 1), EQ, 2), -1);
      ansSkipped := Piece(Piece(TempResult, U, 1), EQ, 2);

      // if question has been skipped, can't add it to the score and can't determine delirium
      if ( (ansSkipped = '') or (ansSkipped = ' ') or
           (ansSkipped = '-1') or
           (ansSkipped = CHOICE_ID_OF_SKIPPED_MULTIPLE_CHOICE_QUESTION) or
           (ansSkipped = CHOICE_ID_OF_SKIPPED_BY_RULE_MC_QUESTION) or
           (ansSkipped = CHOICE_ID_OF_SKIPPED_REQUIRED_ANSWER) ) then
        begin
          if (skip1 = false) and ( (i=1) or (i=2) ) then skip1 := true ;
          if (i=3) then skip3 := true ;
          if (i=6) then skip6 := true ;
          if (i=9) then skip9 := true ;
          if (skip2 = false) and ( (i=5) or (i=8) ) then skip2 := true ;
        end;
{
      begin
        CAM_Result := 'All questions needed to determine if delirium is supported were ' +
                      'not answered. A diagnosis of delirium could not be determined.';
        Result := 'CAM^^' + CAM_Result + RECORD_END;
        exit;
      end;
}

      if (i = 1) then Q1 := TempAnswer ; // Question 1
      if (i = 2) then Q2A := TempAnswer ;
      if (i = 3) then Q2B := TempAnswer ;
      if (i = 5) then Q3A := TempAnswer ;
      if (i = 6) then Q3B := TempAnswer ;
      if (i = 8) then Q4A := TempAnswer ;
      if (i = 9) then Q4B := TempAnswer ;


    end;
    {*
    showmessage('Q1 = ' + inttostr(Q1) + #13 + 'Q2A ' + inttostr(Q2A) + #13 +
                'Q2B = ' + inttostr(Q2B) + #13 + 'Q3A ' + inttostr(Q3A) + #13 +
                'Q3B = ' + inttostr(Q3B) + #13 + 'Q4A ' + inttostr(Q4A) + #13 +
                'Q4B = ' + inttostr(Q4B) + #13#13 + 'skip1: ' + booltostr(skip1) + #13 +
                'skip2: ' + booltostr(skip2) + #13 + 'skip3: ' + booltostr(skip3) + #13 +
                'skip6: ' + booltostr(skip6) + #13 + 'skip9: ' + booltostr(skip9));
    *}

    if (skip1=true) or (skip2=true) or ( (skip3 = true) and (skip6=true) and (skip9=true) )   then
      begin
        CAM_Result := 'All questions needed to determine if delirium is supported were ' +
                      'not answered. A diagnosis of delirium could not be determined.';
        Result := 'CAM^^' + CAM_Result + RECORD_END;
        exit;
      end;

    if ( (Q1 = 1) and ( (Q2B = 1) or (Q3B = 1) or (Q4B = 1) ) and (( Q2A = 1) or (Q2A = 2)) ) AND
         ( ((Q3A = 1) or (Q3A = 2)) or ( (Q4A = 1) or (Q4A = 2) or (Q4A = 3) or (Q4A = 4) ))  then
      CAM_Result := 'The results of the CAM suggest probable delirium.'
    else if
       ( (Q1 = 1) and ( (Q2B <> 1) or (Q3B <> 1) or (Q4B <> 1) ) and (( Q2A = 1) or (Q2A = 2)) ) AND
         ( ( ( Q3A = 1) or (Q3A = 2)) or ( (Q4A = 1) or (Q4A = 2) or (Q4A = 3) or (Q4A = 4) ))  then
      CAM_Result := 'The results of the CAM suggest possible delirium.'
    else
      CAM_Result := 'The results of the CAM do not suggest the presence of delirium.' ;

  // Note: "CAM" is the name of the scale and it must be used here.
  // ~ScaleName^ScaleIEN^ScaleScore~
  Result := 'CAM^^' + CAM_Result + RECORD_END;
end;


function ProgressNote_CAM(
  PatientName,
  PatientDOB,
  PatientSex,
  ScoreString,
  AnswerString: string): string;
// The header, footer and questions and answers are handled elsewhere; avoiding
// broker calls here.

const
  Indent                      : string = '   ';

begin
  Result := '';

  if (ScoreString = '') or (AnswerString = '') then
    Exit;

  Result := Piece(Piece(ScoreString, RECORD_END, 1), U, 3);

end;

end.

