unit uIA_Const;

interface

uses
  Graphics,
  Windows,
  Classes;

const
  U                           = '^';
  CRLF                        = #13#10;
  DATE_TIME_FORMAT            = 'mm/dd/yyyy hh:nn:ss AM/PM';

  DATA                        = '[DATA]';
  BAD_DATA                    = '[BAD DATA]';
  NA                          = 'NA';
  NOT_ASKED                   = 'NOT ASKED';
  SKIPPED                     = 'SKIPPED';
  SKIPPED_BY_RULE             = 'Not asked (due to responses to other questions)';
  SKIPPED_BUT_REQUIRED        = 'Skipped, but required';
  BLANK                       = 'Left blank by the user.';
  UNDEFINED                   = 'UNDEFINED';
  RECORD_END                  = '~';
  END_OF_REPORT               = '$~';
  NO_ID                       = '-1';
  OK                          = 'OK';
  EQ                          = '=';
  CARRIAGE_RETURN_MARKER      = #124; // Vista can not handle #13. Use #124 for conversion.

  LEFT_JUSTIFY                = 'Left';
  CENTER_JUSTIFY              = 'Center';
  RIGHT_JUSTIFY               = 'Right';

  YES                         = 'YES';
  NO                          = 'NO';

  RIGHT_TAB_MAX               = 25;
  DEFAULT_EDIT_BOX_WIDTH      = -1;
  DELIMITER                   : Char = '|';
  SCRIPT_DELIMITER            : Char = '`';
  SAME_LINE                   : Char = 'S';
  NEXT_LINE                   : Char = 'N';
  SEPARATOR                   : Char = #160; // Unseen char for identifying designator and
  // question text.


  // Response Type Strings: These come back from the M-side (all caps)
  MCHOICE_RT                  = 'MCHOICE';
  INTEGER_RT                  = 'INTEGER';
  STRING_RT                   = 'STRING';
  DATE_RT                     = 'DATE';
  MEMO_RT                     = 'MEMO';
  CURRENCY_RT                 = 'CURRENCY';
  TRACKBAR_RT                 = 'TRACK BAR';
  REAL_RT                     = 'REAL';
  VISTA_RT                    = 'VISTA';
  MASKEDIT_RT                 = 'MASKEDIT';
  CHECKLIST_RT                = 'CHECKLIST';

  COMBOBOX_AC                 = 'CO';
  CHECKLIST_AC                = 'CH';
  LISTBOX_AC                  = 'LI';
  RADIOGROUP_AC               = 'RA';
  EDIT_AC                     = 'ED';
  MASKEDIT_AC                 = 'MA';
  SPINEDIT_AC                 = 'SP';
  MEMO_AC                     = 'ME';
  DATEPICKER_AC               = 'DA';
  TRACKBAR_AC                 = 'TR';
  ORCOMBOBOX_AC               = 'OR';
  ORSTAFFCOMBOBOX_AC          = 'OS';
  ORCONSULTCOMBOBOX_AC        = 'OC';

  //Constants used by Rules
  OPERATOR_STRINGS            = 'Equals^Does not equal^Is less than^Is greater than^'
    + 'Equals or is less than^Equals or is greater than';
  DATE_STR                    = 'DATE';
  NUMBER_STR                  = 'NUMBER';
  STRING_STR                  = 'STRING';
  INTERVAL_STR                = 'INTERVAL';

  BLANK_DATE                  = '12/30/1899'; // Used by TJvDatePickerEdit for empty date field

  CHOICE_ID_OF_SKIPPED_QUESTION = '1155';
  CHOICE_ID_OF_SKIPPED_BY_RULE_QUESTION = '1156';
  CHOICE_ID_OF_SKIPPED_REQUIRED_QUESTION = '1157';

  MASK_BLANK                  : string = '      ';
  MASK_ZIP                    : string = '00000;1;_';
  MASK_ZIP_PLUS               : string = '00000\-9999;1;_';
  MASK_PHONE                  : string = '!\(999\) 000-0000;1;_';
  MASK_SSN                    : string = '000\-00\-0000;1;_';

  FILE_NAME_DELIMITER         : char = '~';
  CRASH_FILE_EXT              : string = 'crs';
  RESOURCE_FILE_EXT           : string = 'rsc';
  ADMIN_FILE_EXT              : string = 'adm';
  ANSWER_FILE_EXT             : string = 'ans';
  //IMPORT_FILE_EXT : string = 'iie';

  START_SCRIPT                : string = '<_'; // Used in Report-Template scripts
  END_SCRIPT                  : string = '_>';
  START_TEXT                  : string = '<.';
  END_TEXT                    : string = '.>';
  START_ANSWER                : string = '<*';
  END_ANSWER                  : string = '*>';
  START_SCALE                 : string = '<-';
  END_SCALE                   : string = '->';

  DATE_OPERATOR_STRINGS       = 'is same date as^is earlier than^is later than^is before today^'
    + 'is after today';

var
  gvCPRS_Instance_Handle      : HWND = 0;

  gvNameOfInstrument,
    gvReportTemplate,
    gvString,
    gvInstrumentFile, // Full file name for Instrument.iie file
    gvCurrentComp             : string;

  gvCurrentResult,
    gvDPI,
    gvWhichScaleGroup,
    gvWhichScale,
    gvWhichKey,
    gvInstrumentNumber,
    gvQuestionOrder, // Auto increment for items
    gvDefaultEditWidth,
    gvQuestionLeft, // Default left margin
    gvScrollBarWidthWS, // Horizontal adjustment for width of scroll bar in workspace
                        // and includes the width of the Right Tabs, if present.
  gvQuestionSpace,
    gvQuestionTop, // When building sub-form, used to set Item's top position
    gvTrackBarIndent,
    gvHelpContext,
    gvHighlightForeground,
    gvHighlightBackground,
    gvTop,
    gvLeft,
    gvHeight,
    gvWidth,
    gvLeftMargin,
    gvRightMargin,
    gvTopMargin,
    gvBottomMargin            : integer;

  gvSpeedTab,
    gvUseDesignFont,
    gvPriorAnswers,
    gvUseScreenReader         : Boolean;

  gvFont                      : TFont;

implementation

end.

